program setregionmask

!-------------------------------------------------------------------
! PURPOSE:
! o Reads POP input binaries kmt.da & grid.pop.da for a given grid,
!   and writes out a region.ieeei4 file.
! o For modern topography, generates full region set; for paleo
!   topography, generates north/south mask.
! o USER must specify boundary segment start/end points which, 
!	together with land, will completely box in a region.  A
!	boundary set for one region also serves as a boundary
!	for the region immediately adjacent.
!   AND
!	must provide a seed point (i_region,j_region) from which 
!	a given region will be filled.
!
!-------------------------------------------------------------------
!
!	Compile on dataproc with f90 setregionmask.f90
!
!-------------------------------------------------------------------

implicit none

!--- local ---

   integer :: imt, jmt, i, j, k, recl_factor,nb,nbad
   integer :: imiss=99
   logical :: paleo
   integer*4, allocatable :: kmt(:,:), mask(:,:), cnt(:,:)
   real*8, allocatable :: ulat(:,:),ulng(:,:),tlat(:,:),tlng(:,:)
   real :: atlantic(7,4),pacific(5,4),indian(1,4)
   real :: north(4),northsea(2,4),labrador(2,4)
   character(len=80) :: gridf, kmtf, maskf

!  line segments which demarc region boundaries 
! 		        /x0,  y0,  x1,  y1/  in degrees
!
   data north(1:4)      /0., 0., 360., 0. /	  !N. Hemisphere
   data atlantic(1,1:4) /300.,-32., 22., -32. /	  !S. Atlantic
   data atlantic(2,1:4) /353., 32., 353., 39. /	  !Med.
   data atlantic(3,1:4) /12., 51., 12., 60. /	  !Baltic
   data atlantic(4,1:4) /8., 60., 341., 65. /	  !Finland-Iceland
   data atlantic(5,1:4) /341., 65., 325., 72. /	  !Iceland-Greenland
   data atlantic(6,1:4) /315., 62., 315., 50. /	  !Greenland-Atlantic
   data atlantic(7,1:4) /315., 50., 300., 50. /	  !Atlantic-NovaScotia
   data pacific(1,1:4) /143.,-32., 300., -32. /	  !S. Pacific
   data pacific(2,1:4) /142.,-20., 142., -6. /	  !Torres Strait (?)
   data pacific(3,1:4) /130.,-1.5, 116., -1.5 /	  !Borneo Strait (?)
   data pacific(4,1:4) /98.5,-1.8, 112., -1.8 /	  !Java Strait (?)
   data pacific(5,1:4) /180.,66., 203., 66. /	  !Bering Strait
   data indian(1,1:4) /26.,-32., 117., -32. /	  !S. Pacific
   data northsea(1,1:4) /26.,70., 16.6, 79. / 
   data northsea(2,1:4) /16.6,79., 336., 81. / 
   data labrador(1,1:4) /286.5,61.,290.5,64./ 
   data labrador(2,1:4) /279.,73.7,275.,78./ 

   print *, 'Enter grid dimensions : imt, jmt'
   read *, imt, jmt
   print *, 'Enter name of POP grid binary:'
   read *, gridf
   print *, 'Enter name of POP kmt binary:'
   read *, kmtf
   print *, 'Enter name of POP region mask binary (output):'
   read *, maskf
   print *, 'Is this a paleo grid (T/F)?'
   read *, paleo

   allocate(kmt(imt,jmt))
   allocate(mask(imt,jmt))
   allocate(cnt(imt,jmt))
   allocate(ulat(imt,jmt))
   allocate(ulng(imt,jmt))
   allocate(tlat(imt,jmt))
   allocate(tlng(imt,jmt))

   open (1, file=kmtf, access='direct', &
     form='unformatted', recl=jmt*imt*4, status='old')
   open (2, file=gridf, access='direct', &
     form='unformatted', recl=jmt*imt*8, status='old')
   open (3, file=maskf, access='direct', &
     form='unformatted', recl=jmt*imt*4, status='unknown', &
     action='write')

! read in kmt and grid:
   read  (1, rec=1) kmt
   read  (2, rec=1) ulat 
   read  (2, rec=2) ulng
   close(1)
   close(2)

! get T grid locations
   call calc_tpoints(imt,jmt,ulng,ulat,tlng,tlat)
     
! mask 99 for ocean, 0 for land
   mask = imiss
   where(kmt == 0) mask=0
   cnt = 0

! set region boundaries (where necessary), then fill
   if (paleo) then
!	For paleo grids, presumably do something simple like
!	Northern Hemisphere & Southern Hemisphere
     nb = size(north,1)
     call set_bounds(imt,jmt,tlng,tlat,mask,nb,north,1,'north')

     call neighbor_fill(imt,jmt,mask,1,3,87,imiss)  ! fill North
     call neighbor_fill(imt,jmt,mask,2,3,40,imiss)  ! fill South
   else
     nb = size(atlantic,1)
     call set_bounds(imt,jmt,tlng,tlat,mask,nb,atlantic,6,'atlantic')
     nb = size(pacific,1)
     call set_bounds(imt,jmt,tlng,tlat,mask,nb,pacific,2,'pacific')
     nb = size(indian,1)
     call set_bounds(imt,jmt,tlng,tlat,mask,nb,indian,3,'indian')
     nb = size(northsea,1)
     call set_bounds(imt,jmt,tlng,tlat,mask,nb,northsea,9,'northsea')
     nb = size(labrador,1)
     call set_bounds(imt,jmt,tlng,tlat,mask,nb,labrador,8,'labrador')

!  Filling regions from seed points.  Note that some regions require
!	more than one fill because they are not contiguous
     call neighbor_fill(imt,jmt,mask,6,2,57,imiss) ! fill Atlantic
     call neighbor_fill(imt,jmt,mask,2,66,56,imiss) ! fill Pacific
     call neighbor_fill(imt,jmt,mask,3,29,48,imiss) ! fill Indian
     call neighbor_fill(imt,jmt,mask,1,34,18,imiss) ! fill Southern Ocean
     call neighbor_fill(imt,jmt,mask,8,92,96,imiss) ! fill Labrador
     call neighbor_fill(imt,jmt,mask,9,19,107,imiss) ! fill North Sea
     call neighbor_fill(imt,jmt,mask,10,53,96,imiss) ! fill Arctic
     call neighbor_fill(imt,jmt,mask,7,16,76,imiss) ! fill Med
     call neighbor_fill(imt,jmt,mask,7,11,76,imiss) ! fill Med
     call neighbor_fill(imt,jmt,mask,-13,20,78,imiss) ! fill Black
     call neighbor_fill(imt,jmt,mask,-14,26,79,imiss) ! fill Caspian
     call neighbor_fill(imt,jmt,mask,-5,22,70,imiss) ! fill Red
     call neighbor_fill(imt,jmt,mask,-5,21,72,imiss) ! fill Red
     call neighbor_fill(imt,jmt,mask,-5,23,67,imiss) ! fill Red
     call neighbor_fill(imt,jmt,mask,4,27,71,imiss) ! fill Persian
     call neighbor_fill(imt,jmt,mask,4,25,72,imiss) ! fill Persian
     call neighbor_fill(imt,jmt,mask,-12,19,87,imiss) ! fill Baltic
     call neighbor_fill(imt,jmt,mask,-12,20,90,imiss) ! fill Baltic
     call neighbor_fill(imt,jmt,mask,11,86,91,imiss) ! fill Hudson

   end if 

   where(mask==imiss) cnt=1
   nbad = sum(cnt)
   if (nbad /= 0) then
      write(6,*) 'Still have ',nbad,' points with unassigned value'
   end if

   write (unit=3, rec=1)mask
   write(6,*) ' '
   write(6,*) 'DONE writing ',maskf

end program setregionmask

!=================================================================

recursive SUBROUTINE neighbor_fill(imt,jmt,mask,value,i0,j0,miss)

!-----------------------------------------------------------------------
!  Recursively fills a region starting from seed point (i0,j0), and
!  filling with "value" wherever north/south/east/west shifts indicate
!  a missing value.
!-----------------------------------------------------------------------

   integer :: i0, j0, imt, jmt, miss, value
   integer :: ie,iw,jn,js
   integer, dimension(imt,jmt) :: mask

   if (mask(i0,j0) == miss) then 
      mask(i0,j0)=value
      iw = iadd(i0,-1,imt)
      call neighbor_fill(imt,jmt,mask,value,iw,j0,miss)
      ie = iadd(i0,1,imt)
      call neighbor_fill(imt,jmt,mask,value,ie,j0,miss)
      jn = iadd(j0,1,jmt)
      call neighbor_fill(imt,jmt,mask,value,i0,jn,miss)
      js = iadd(j0,-1,jmt)
      call neighbor_fill(imt,jmt,mask,value,i0,js,miss)
   end if

END SUBROUTINE neighbor_fill

!=================================================================

SUBROUTINE set_bounds(imt,jmt,tlng,tlat,mask,nb,bounds,value,rstr)

!-----------------------------------------------------------------------
!
!  Sets MASK array to VALUE along linear segments specified in the
!  BOUNDS array (there are NB segments to process for a given region).
!  The line segments are meant to follow great circles which intersect
!  the endpoints in BOUNDS, but in practice, a slope is computed in
!  grid i,j space, and this slope is traced from a mesh starting cell
!  to a mesh ending cell.  
!
!-----------------------------------------------------------------------

   integer :: i, j, k, imt, jmt, nb, value, kcnt, lcnt
   integer :: sti,stj,eni,enj,thisi,thisj
   integer, allocatable :: movei(:),movej(:)
   integer, dimension(imt,jmt) :: mask, iind, jind
   real, dimension(nb,4) :: bounds
   real :: x0,x1,y0,y1
   real*8, dimension(imt,jmt) :: tlng,tlat,dist0,dist1
   real*8  :: mindist0,mindist1
   character(len=*) :: rstr

   rstr = trim(rstr)

   do i=1,imt 
      iind(i,1:jmt)=i
   end do
   do j=1,jmt 
      jind(1:imt,j)=j
   end do

!  loop over number of boundary segments for this region
   do k=1,nb
     sti=0
     stj=0
     eni=0
     enj=0
     lcnt=0
     kcnt=0
     x0 = bounds(k,1)
     y0 = bounds(k,2)
     x1 = bounds(k,3)
     y1 = bounds(k,4)
     dist0 = sqrt((tlng-x0)**2+(tlat-y0)**2)
     dist1 = sqrt((tlng-x1)**2+(tlat-y1)**2)
     mindist0 = 1.e30
     mindist1 = 1.e30
     do j=1,jmt
     do i=1,imt
       if (dist0(i,j)<mindist0) then
         mindist0 = dist0(i,j)
       end if
       if (dist1(i,j)<mindist1) then
         mindist1 = dist1(i,j)
       end if
     end do
     end do

     do j=1,jmt
     do i=1,imt
!    write(6,*) 'i,j,dist0,dist1,mindist0,mindist1',i,j,dist0(i,j), &
! &      dist1(i,j),mindist0,mindist1
       if (dist0(i,j)==mindist0) then
         sti = i
         stj = j
       end if
       if (dist1(i,j)==mindist1) then
         eni = i
         enj = j
       end if
     end do
     end do
     if (min(sti,stj,eni,enj)==0) then
       write(6,*) 'sti,stj,eni,enj = ',sti,stj,eni,enj
       stop 'Did not locate segment endpoint on mesh'
     end if
!    write(6,*) ' '
!    write(6,*) 'processing segment ',k,' of ',rstr
!    write(6,1000) 'starting point: ',x0,y0,'  model grid: ', &
!   &    tlng(sti,stj),tlat(sti,stj)
!    write(6,1000) 'ending point: ',x1,y1,'  model grid: ', &
!   &    tlng(eni,enj),tlat(eni,enj)
1000  format(a16,f7.3,2x,f7.3,a14,f7.3,2x,f7.3)

!   get slope (in units of grid cell steps) from start to end of segment
     idx = eni-sti
     idy = enj-stj
     if (abs(idx) > imt/2) then
       if (idx > 0) idx = idx-imt
       if (idx < 0) idx = idx+imt
     end if
     nidx = abs(idx)
     nidy = abs(idy)

!    factor out common denominators in slope idy/idx
10   continue
     do i=2,min(nidx,nidy)
       if (mod(idx,i)==0 .and. mod(idy,i)==0) then
          idx = idx/i
          idy = idy/i
          goto 10
       end if
     end do

!   now that slope is reduced, determine best move sequence
!    write(6,*) 'using slope DY = ',idy,' DX = ',idx
     nmove = nidx+nidy
     allocate(movei(nmove))
     allocate(movej(nmove))
     call get_moves(nmove,idx,idy,movei,movej)
!    write(6,*) 'movei = ',(movei(i),i=1,nmove)
!    write(6,*) 'movej = ',(movej(i),i=1,nmove)

!    step from starting point on mesh (sti,stj) to adjacent cells until
!    you get to the grid cell nearest the segment end (eni,enj)
!    Set ocean point mask to "value", leave land point mask values 0
     thisi = sti
     thisj = stj
     if (mask(thisi,thisj) /= 0) mask(thisi,thisj) = value
     do
       do i=1,nmove
	thisi=iadd(thisi,movei(i),imt)
	thisj=jadd(thisj,movej(i),jmt)
        kcnt = kcnt + 1
!       write(6,*) thisi,thisj,mask(thisi,thisj)
        if (mask(thisi,thisj) /= 0) then
	   mask(thisi,thisj) = value
	   lcnt = lcnt+1
        end if
        if (thisi==eni .and. thisj==enj) exit
       end do
       if (thisi==eni .and. thisj==enj) exit
       if (kcnt > 100) stop 'not getting anywhere'
     end do
!    write(6,*) 'assigned region value to ',lcnt,' cells'

     deallocate(movei)
     deallocate(movej)
   end do	! k, loop over nb boundary segments

END SUBROUTINE set_bounds

!***********************************************************************

integer FUNCTION iadd(i,di,ni)

   implicit none

   !--- arguments ---
   integer :: i, di, ni

   if (di < 0) then
     iadd = mod(i+di-1+ni,ni)+1
   else
     iadd = mod(i,ni)+di
   endif

END FUNCTION iadd

!===============================================================================

integer FUNCTION jadd(j,dj,nj)

   implicit none

   !--- arguments ---
   integer :: j, dj, nj

   if (dj < 0) then
     jadd = max(j+dj,1)
   else
     jadd = min(j+dj,nj)
   endif

END FUNCTION jadd

!===============================================================================

SUBROUTINE get_moves(nmove,idx,idy,movei,movej)

!-----------------------------------------------------------------------
!
!     For a slope in i,j grid space given by idy & idx, this
!	routine determines a set of adjacent cell moves to
!	accomplish this slope in the most linear fashion possible.
!	The moves are stored as 1-D arrays movei, movej which
!	hold values of -1, 0, or 1.
!
!-----------------------------------------------------------------------

   integer ::  i, j , nmove, idx, idy, nidx, nidy, cnt
   integer, dimension(nmove) ::  tmp1, tmp2, movei, movej

   movei = 0
   movej = 0
   cnt = 0
   nidx = abs(idx)
   nidy = abs(idy)

!  cannot improve the linearity when either idx or idy <= 1
   if (min(nidx,nidy) <= 1) then
      do j=1,nidy
        cnt = cnt + 1
	movej(cnt)=idy/nidy
      end do
      do i=1,nidx
        cnt = cnt + 1
        movei(cnt)=idx/nidx
      end do
      return
   end if

!  
   if (nidy>nidx) then
      slp = nint(real(nidy)/real(nidx))
      nfull = min(int(nidy/slp),nidx)
      nxleft = nidx-nfull
      nyleft = nidy-(slp*nfull)
      cnt = 0
      do i=1,nfull
         cnt = cnt + 1
         movei(cnt) = idx/nidx
         do j=1,slp
           cnt = cnt + 1
           movej(cnt) = idy/nidy
         end do
      end do
      do i=1,nxleft
        cnt = cnt + 1
        movei(cnt) = idx/nidx
      end do
      do j=1,nyleft
         cnt = cnt + 1
         movej(cnt) = idy/nidy
      end do
   else			! nidx>nidy since they can't be equal
      slp = nint(real(nidx)/real(nidy))
      nfull = min(int(nidx/slp),nidy)
      nyleft = nidy-nfull
      nxleft = nidx-(slp*nfull)
      cnt = 0
      do i=1,nfull
         cnt = cnt + 1
         movej(cnt) = idy/nidy
         do j=1,slp
           cnt = cnt + 1
           movei(cnt) = idx/nidx
         end do
      end do
      do i=1,nyleft
        cnt = cnt + 1
        movej(cnt) = idy/nidy
      end do
      do j=1,nxleft
         cnt = cnt + 1
         movei(cnt) = idx/nidx
      end do
   end if

END SUBROUTINE get_moves

!***********************************************************************

SUBROUTINE calc_tpoints(imt,jmt,ux,uy,tlng,tlat)

!-----------------------------------------------------------------------
!
!     calculates lat/lon coordinates of T points from U points.
!     this computation is identical to the method used in the ccsm
!     ice model subroutine Tlatlon in module ice_gird.F as of
!     14 September 2001
!
!-----------------------------------------------------------------------

   integer ::  i, j , im1, imt, jmt
   real*8, parameter :: pi=3.14159265358979323846
   real*8 :: z1,x1,y1,z2,x2,y2,z3,x3,y3,z4,x4,y4,tx,ty,tz,da
   real*8, intent(in), dimension(imt,jmt) :: ux, uy
   real*8, intent(out), dimension(imt,jmt) :: tlat, tlng

   write(6,*) 'ux[50,50] = ',ux(50,50)*(180./pi)
   write(6,*) 'uy[50,50] = ',uy(50,50)*(180./pi)
      do j=2,jmt
        do i=1,imt

            if (i.eq.1) then
               im1=imt
            else
               im1=i-1
            endif

            z1 = cos(uy(im1,j-1))
            x1 = cos(ux(im1,j-1))*z1
            y1 = sin(ux(im1,j-1))*z1
            z1 = sin(uy(im1,j-1))

            z2 = cos(uy(i,j-1))
            x2 = cos(ux(i,j-1))*z2
            y2 = sin(ux(i,j-1))*z2
            z2 = sin(uy(i,j-1))

            z3 = cos(uy(im1,j))
            x3 = cos(ux(im1,j))*z3
            y3 = sin(ux(im1,j))*z3
            z3 = sin(uy(im1,j))

            z4 = cos(uy(i,j))
            x4 = cos(ux(i,j))*z4
            y4 = sin(ux(i,j))*z4
            z4 = sin(uy(i,j))

            tx = (x1+x2+x3+x4)/c4
            ty = (y1+y2+y3+y4)/c4
            tz = (z1+z2+z3+z4)/c4
            da = sqrt(tx**2+ty**2+tz**2)

            tz = tz/da
            ! tlng in radians
            tlng(i,j) = 0.0
            if (tx.ne.0.0.or.ty.ne.0.0) &
                 tlng(i,j) = atan2(ty,tx)
            ! tlat in radians
            tlat(i,j) = asin(tz)

        end do
      end do

      ! j=1: linear approximation
      do i=1,imt
         tlng(i,1) = tlng(i,2)
         tlat (i,1) = 2.0*tlat(i,2) - tlat(i,3)
      end do

      where (tlng > 2.*pi) tlng = tlng - 2.*pi
      where (tlng < 0.0 ) tlng = tlng + 2.*pi

! convert to degrees
    tlat = tlat*(180./pi)
    tlng = tlng*(180./pi)
   write(6,*) 'tx[50,50] = ',tlng(50,50)
   write(6,*) 'ty[50,50] = ',tlat(50,50)
!-----------------------------------------------------------------------

END SUBROUTINE calc_tpoints

      program ns_dipole

      implicit none

      integer nlng,nlat,nlat_n,nlat_s,ndelta,jcon,n
      integer i,j,jm1,jp1,im1,ip1
      integer recl_dbl
      real*8 phi_pole_n,lambda_pole_n,phi_pole_s,lambda_pole_s
      real*8 deq,dsig,pi,dx,delta_pole,delta
      real*8 recl_dbl_tmp
      real*8, allocatable :: ulat_n(:,:),ulng_n(:,:),utan_n(:,:)
      real*8, allocatable :: htn_n(:,:),hte_n(:,:)
      real*8, allocatable :: ulat_s(:,:),ulng_s(:,:),utan_s(:,:)
      real*8, allocatable :: htn_s(:,:),hte_s(:,:)
      real*8, allocatable :: ulat(:,:),ulng(:,:),utan(:,:)
      real*8, allocatable :: htn(:,:),hte(:,:)
      real*8, allocatable :: hus(:,:),huw(:,:)
      character*80 filename

      pi = 3.141592653589793d0

      print *, " "
      print *, "nlng:    # zonal grid points"
      print *, "nlat_n:  # meridional grid points in northern hemishere"
      print *, "nlat_s:  # meridional grid points in southern hemishere"
      print *, " "
      print *, "enter nlng, nlat_n, nlat_s"
      read(*,*) nlng,nlat_n,nlat_s
      print *, ">>>>>",nlng,nlat_n,nlat_s

      nlat = nlat_s + nlat_n 

      INQUIRE(IOLENGTH=recl_dbl) recl_dbl_tmp

      print *, " "
      print *, "global array dimensions are: ", nlng, nlat

      print *, " "
      print *, " lamda_pole_n : longitude of northern grid pole"
      print *, "   phi_pole_n :  latitude of northern grid pole"
      print *, " lamda_pole_s : longitude of southern grid pole"
      print *, "   phi_pole_s :  latitude of southern grid pole"
200   print *, " "
      print *, "enter lambda_pole_n,phi_pole_n (degrees)"
      read(*,*) lambda_pole_n,phi_pole_n
      print *, ">>>>>",lambda_pole_n,phi_pole_n
      if(phi_pole_n.le.0.d0) then
        print *, " "
        print *, " north grid pole latitude must be > 0"
        go to 200
      endif
      if(abs(lambda_pole_n).gt.180.d0) then
        print *, " "
        print *, 
     &  "enter a lambda_pole_n between -180 (180W) and +180 (180E)"
        go to 200
      endif

300   print *, " "
      print *, "enter lambda_pole_s,phi_pole_s (degrees)"
      read(*,*) lambda_pole_s,phi_pole_s
      print *, ">>>>>",lambda_pole_s,phi_pole_s
      if(phi_pole_s.ge.0.d0) then
        print *, " "
        print *, " south grid pole latitude must be < 0"
        go to 300
      endif
      if(abs(lambda_pole_s).gt.180.d0) then
        print *, " "
        print *, 
     &  "enter a lambda_pole_s between -180 (180W) and +180 (180E)"
        go to 300
      endif

      dx = 360.d0/float(nlng)
      delta_pole = lambda_pole_n - lambda_pole_s
      delta = delta_pole/dx
      ndelta = nint(delta)
      if (delta.ne.float(ndelta)) then
        delta_pole = float(ndelta)*dx
        lambda_pole_s = lambda_pole_n - delta_pole
        print *, " "
        print *, " Longitudes of north and south grid poles"
        print *, " must differ by an integer times the "
        print *, " Equatorial grid spacing. Southern"
        print *, " grid pole latitude has been changed"
        print *, " to the nearest allowed value:"
        print *, "   lambda_pole_s = ",lambda_pole_s
        print *, "   delta_pole    = ",delta_pole
      endif

      lambda_pole_n=lambda_pole_n*pi/180.d0
      phi_pole_n=phi_pole_n*pi/180.d0
      lambda_pole_s=lambda_pole_s*pi/180.d0
      phi_pole_s=phi_pole_s*pi/180.d0
      delta_pole = delta_pole*pi/180.d0

      print *, " "
      print *, "deq : the desired meridional spacing along the Equator"
      print *, "dsig: gaussian half width for meridional profile for"
      print *, "      enhanced meridional spacing along the Equator:"
      print *, "jcon: if not 0, forces (nearly) constant meridional"
      print *, "      grid spacing in the last jcon rows of cells next"
      print *, "      to the grid poles (used to move grid boundaries "
      print *, "      closer to the grid poles without increasing nlat"
      print *, " "
      print *, "enter deq, dsig (degrees), jcon"
      read(*,*) deq,dsig,jcon
      print *, ">>>>>",deq,dsig,jcon

c     ...allocate northern grid

      allocate (ulat_n(nlng,0:nlat_n))
      allocate (ulng_n(nlng,0:nlat_n))
      allocate (utan_n(nlng,0:nlat_n))
      allocate (hte_n(nlng,0:nlat_n))
      allocate (htn_n(nlng,0:nlat_n))

c     ...calculate northern grid

      print *, " "
      print *, " NORTHERN GRID:"

      call northern_dipole(nlng,nlat_n            ! input
     &   ,phi_pole_n,lambda_pole_n,deq,dsig,jcon  ! input
     &   ,ulat_n,ulng_n,htn_n,hte_n,utan_n)       ! output

c     ...allocate southern grid

      allocate (ulat_s(nlng,0:nlat_s))
      allocate (ulng_s(nlng,0:nlat_s))
      allocate (utan_s(nlng,0:nlat_s))
      allocate (hte_s(nlng,0:nlat_s))
      allocate (htn_s(nlng,0:nlat_s))

c     ...calculate southern grid

      print *, " "
      print *, " SOUTHERN GRID:"

      call northern_dipole(nlng,nlat_s             ! input
     &   ,-phi_pole_s,lambda_pole_s,deq,dsig,jcon  ! input
     &   ,ulat_s,ulng_s,htn_s,hte_s,utan_s)        ! output

c     ...shift southern grid arrays to align with northern grid

      ulat_s = cshift(ulat_s,ndelta,1)
      ulng_s = cshift(ulng_s,ndelta,1)
      utan_s = cshift(utan_s,ndelta,1)
      htn_s  = cshift(htn_s ,ndelta,1)
      hte_s  = cshift(hte_s ,ndelta,1)

c     ...allocate global grid

      allocate (ulat(nlng,0:nlat))
      allocate (ulng(nlng,0:nlat))
      allocate (utan(nlng,0:nlat))
      allocate (hte(nlng,0:nlat))
      allocate (htn(nlng,0:nlat))
      allocate (hus(nlng,0:nlat))
      allocate (huw(nlng,0:nlat))

c     ...write southern grid into global arrays

      ulng(:,0:nlat_s) =  ulng_s(:,nlat_s:0:-1)
      ulat(:,0:nlat_s) = -ulat_s(:,nlat_s:0:-1)
      utan(:,0:nlat_s) = -utan_s(:,nlat_s:0:-1)
      htn (:,0:nlat_s) =  htn_s (:,nlat_s:0:-1)
      hte (:,1:nlat_s) =  hte_s (:,nlat_s:1:-1)

c     ...write northern grid into global arrays

      ulng(:,nlat_s:nlat) =  ulng_n(:,0:nlat_n)
      ulat(:,nlat_s:nlat) =  ulat_n(:,0:nlat_n)
      utan(:,nlat_s:nlat) =  utan_n(:,0:nlat_n)
      htn (:,nlat_s:nlat) =  htn_n (:,0:nlat_n)
      hte (:,nlat_s+1:nlat) =  hte_n (:,1:nlat_n)

c     ...calculate hus,huw

      do j = 1,nlat
         jm1 = j-1
         jp1 = j+1
         if (j.eq.1) jm1 = 1
         if (j.eq.nlat) jp1 = nlat
         do i = 1,nlng
            im1 = i-1
            ip1 = i+1
            if (i.eq.1) im1 = nlng
            if (i.eq.nlng) ip1 = 1
            hus(i,j) = 0.25d0*(htn(i  ,j) + htn(i  ,jm1)
     &                       + htn(ip1,j) + htn(ip1,jm1))
            huw(i,j) = 0.25d0*(hte(i,  j) + hte(im1,j  )
     &                       + hte(i,jp1) + hte(im1,jp1))
         enddo
      enddo

c999  continue
c     print *, " "
c     print *, "print column of ulngs, ulats, enter i "
c     print *, "(-1 to continue)"
c     read(*,*)i
c     if(i.eq.-1)go to 1000
c     do j=0,nlat
c      print *,j,ulng(i,j),ulat(i,j),htn(i,j),hte(i,j)
c      print *,j,htn(i,j),hte(i,j),hus(i,j),huw(i,j)
c     enddo 
c     go to 999
c1000 continue

c     ...write direct access grid file grid.plot.da for plotting

      print *, " "
      print *, "enter: "
      print *, "  0 to continue "
      print *, "  1 to output ulat, ulng to direct access file"
      read(*,*) n
      print *, ">>>>>",n

      if(n.eq.1) then

      print *, "enter name of direct access file containing"
      print *, "double-precision fields:"
      print *, "ulat(1:nlng,0:nlat),ulng(1:nlng,0:nlat)"
      read(*,'(a80)') filename
      print *, ">>>>>",filename

      open (53, file=filename, form='unformatted', status='unknown',
     & access='direct',action='write',recl=(nlat+1)*nlng*8)
      write (53,rec=1) ulat
      write (53,rec=2) ulng
      close(53)
      print *, " "
      print *, " file written: ", filename

      endif

c     ...write direct access grid file grid.pop.da for POP

      print *, " "
      print *, "enter: "
      print *, "  0 to continue "
      print *, "  1 to direct access grid file for POP"
      read(*,*) n
      print *, ">>>>>",n

      if(n.eq.1) then

        print *, "enter name of direct access POP grid file"
        print *, "containing double-precision fields:"
        print *, " ulat(1:nlng,1:nlat)"
        print *, " ulng(1:nlng,1:nlat)"
        print *, "  htn(1:nlng,1:nlat)"
        print *, "  hte(1:nlng,1:nlat)"
        print *, "  hus(1:nlng,1:nlat)"
        print *, "  huw(1:nlng,1:nlat)"
        print *, " angle(1:nlng,1:nlat)"
        read(*,'(a80)') filename
      print *, ">>>>>",filename

c      print *, "ulat(370,280) = ",ulat(370,280)
c      print *, "ulng(370,280) = ",ulng(370,280)
c      print *, "htn(370,280) = ",htn(370,280)
c      print *, "hte(370,280) = ",hte(370,280)
c      print *, "hus(370,280) = ",hus(370,280)
c      print *, "huw(370,280) = ",huw(370,280)
c      print *, "utan(370,280) = ",utan(370,280)
       print *, "recl_dbl = ",recl_dbl

        open (53, file=filename, form='unformatted', status='unknown',
     &   access='direct',action='write',recl=nlat*nlng*recl_dbl)
        write (53,rec=1) ulat(:,1:nlat)
        write (53,rec=2) ulng(:,1:nlat)
        write (53,rec=3) htn(:,1:nlat)
        write (53,rec=4) hte(:,1:nlat)
        write (53,rec=5) hus(:,1:nlat)
        write (53,rec=6) huw(:,1:nlat)
        write (53,rec=7) utan(:,1:nlat)
        close(53)
        print *, " "
        print *, " file written: ", filename
      endif

c     ...write ascii grid file grid.ascii for VTK

c     print *, " "
c     print *, " enter (1/0) to write a ascii grid file for VTK"
c     read(*,*) i

c     if (i.eq.1) then
c       filename = './grid.ascii'
c       open(53,file=filename,form='formatted',status='unknown')
c       write (53,*)
c    &  'DIPOLE GRID:  ULAT, ULNG, I,    J,     
c    &  HTN,     HTE,     HUS,     HUW,     UTAN'
c       write (53,'(6i8)') nlng,                    ! Num of I-values
c    &                  1 + nlat,                   ! Num of J-values
c    &                  nlng/2,                        ! Crossover I index
c    &                  nlng-1,                 ! (==East I index)
c    &                  nlat/2,                          ! Crossover J index
c    &                  nlat                      ! North J index
c       do j = 0, nlat
c         write (53,*) 'ROW J = ', j
c           ! At a roughly constant latitude J, loop over the longitude
c           ! points and write records LON, LAT, I, J.
c         do i =  1,nlng
c             write (53,'(2f15.7,2i9,x,f15.7
c    &         ,x,f15.7,x,f15.7,x,f15.7,x,f15.7)') 
c    &        -180.0+ulng(i,j)*180.d0/pi, ulat(i,j)*180./pi, i-1, j 
c    &      , htn(i,j)*0.01, hte(i,j)*0.01                
c    &      , hus(i,j)*0.01, huw(i,j)*0.01                
c    &      , utan(i,j)*180./pi
c         end do
c       end do
c       close(53)
c       print *, " "
c       print *, " file written: ", filename
c     endif

      end
 
c*********************************************************************
c*********************************************************************

      subroutine northern_dipole(nlng,nlat    ! input
     &   ,phi_pole,lambda_pole,deq,dsig,jcon  ! input
     &   ,ulat,ulng,htn,hte,utan)             ! output

      implicit none

      integer nlng,nlat,jcon,nlast,i,j,j_match
      double precision phi_pole,lambda_pole,fi,pi,phi_match
      double precision ulat(nlng,0:nlat),ulng(nlng,0:nlat)
      double precision utan(nlng,0:nlat)
      double precision hte(nlng,0:nlat),htn(nlng,0:nlat)
      double precision deq,dsig,xsquare
      double precision xdeg(nlng),ydeg(0:nlat)
      double precision x0(1:nlng),y0(1:nlng),z0(1:nlng)

c---------------------------------------------------------------------
c     set some constants, initialize output arrays
c---------------------------------------------------------------------

      pi = 3.141592653589793d0 
      xsquare = 0.5d0*pi
      nlast = 10000
c     jcon = 0
      j_match = 0
      phi_match = 0.d0

      ulat = 0.d0
      ulng = 0.d0
      utan = 0.d0
      htn = 0.d0
      htn = 0.d0
      hte = 0.d0

c---------------------------------------------------------------------
c     calculation of x-spacing at equator
c---------------------------------------------------------------------

c     ... constant x-spacing assumed

      fi = 2.0d0*pi/float(nlng)
      do i = 1,nlng
        xdeg(i) = i*fi
        ulat(i,j_match) = phi_match
        ulng(i,j_match) = xdeg(i)*cos(phi_match)
      enddo
 
c---------------------------------------------------------------------
c     calculation of the grid
c---------------------------------------------------------------------
 
      call gridgen(nlng,nlat                           ! input
     &            ,phi_pole,lambda_pole,phi_match,xdeg ! input
     &            ,j_match,jcon,nlast,deq,dsig,xsquare ! input
     &            ,ulat,ulng                           ! input, output
     &            ,htn,hte,utan)               ! output 
 
      end

c*********************************************************************
c*********************************************************************

      subroutine gridgen(nlng,nlat                         !input
     &            ,phi_pole,lambda_pole,phi_match,xdeg     ! input
     &            ,j_match,jcon,nlast,deq,dsig,xsquare     ! input
     &            ,ulat,ulng                           ! input, output
     &            ,htn,hte,utan)                   ! output)
 
c---------------------------------------------------------------------
c     this routine generates grid variables for a composite
c     mesh consisting of a polar mesh below phi = phi_match
c     and a distorted mesh with a displace pole for
c     phi > phi_match
c---------------------------------------------------------------------
c     input variables (all angles in radians):
c
c       phi_pole     latitude  of true displaced pole 
c       lambda_pole       longitude of true displaced pole
c       phi_match    latitude  where grids match together 
c       ydeg(0:nlat)      latitude spacing at lambda_pole + xsquare
c---------------------------------------------------------------------
c     output variables:
c
c       ulat,ulng,utan,hte,htn
c---------------------------------------------------------------------
 
      implicit none

      integer nlng,nlat,j_match,jcon,nlast
      double precision p25
     &  , del, dmin, dmax, alpha0, phi0, fy, dxavg, phiold
     &  , phi_match, dy, yy, aspect, dxmin, dymin
     &  , deq, dsig, xsquare
      double precision radius,delta,c0,d0,c00,d00,yl,yu,gg
      double precision lambda_pole,phi_pole,smean,srms
      double precision x0(nlng),y0(nlng),z0(nlng)
      double precision x00(nlng),y00(nlng),z00(nlng)
      double precision ulat(nlng,0:nlat),ulng(nlng,0:nlat)
      double precision utan(nlng,0:nlat)
      double precision hte(nlng,0:nlat),htn(nlng,0:nlat)
c     double precision deq,dsig
      double precision xdeg(nlng),ydeg(0:nlat)
      double precision htep(nlng),htnp(nlng)
      integer i,j,im1,ip1,jm1,jp1,n,ii,jj,imax,jmax,imin,jmin,nnn,iii
 
      parameter (p25 = 0.25d0)
c     parameter (radius = 6370.0d5)
      parameter (radius = 6371.22d5)
      double precision pi
      parameter (pi = 3.141592653589793d0)

c*********************************************************************

      dxavg = 360.d0/float(nlng)

      dmin = pi
      do i = 1,nlng/2
        delta = abs(xdeg(i)-xsquare)
        if (delta.lt.dmin) then
          dmin = delta
          ii = i
        endif
      enddo

      j = j_match
      delta = cos(phi_match)
      do i = 1,nlng
        ulng(i,j) = xdeg(i)
        ulat(i,j) = phi_match
        if (i.gt.1) then
          htn(i,j) = delta*(ulng(i,j)-ulng(i-1,j))*radius
        else
          htn(i,j) = delta*ulng(i,j)*radius
        endif
      enddo
      ydeg(j) = ulat(nlng/2,j)

      do j = j_match-1,0,-1
	print *,'in AAAA'
        fy = dsig*pi/180.d0
        fy = 1.0d0 - (1.0d0-deq/dxavg)*exp(-0.5d0*(ulat(ii,j+1)/fy)**2)
c       fy = 1.0d0
        jj = j
        if(j.lt.jcon)jj=jcon
        del = (xdeg(ii) - xdeg(ii-1))*cos(ulat(ii,jj+1))*fy
        do i = 1,nlng
          ulng(i,j) = xdeg(i)
          ulat(i,j) = ulat(i,j+1) - del
          hte(i,j+1) = abs(ulat(i,j) - ulat(i,j+1))*radius
          delta = cos(ulat(i,j))
          if (i.gt.1) then
            htn(i,j) = delta*(ulng(i,j)-ulng(i-1,j))*radius
          else
            htn(i,j) = delta*ulng(i,j)*radius
          endif
        enddo
        ydeg(j) = ulat(nlng/2,j)
      enddo

      do j = 0,j_match-1
	print *,'in BBB'
        fy = dsig*pi/180.d0
        fy = 1.0d0 - (1.0d0-deq/dxavg)*exp(-0.5d0*(ulat(ii,j+1)/fy)**2)
c       fy = 1.0d0
c       print *,j,ydeg(j)*180.d0/pi,fy
      enddo

c   ... initialize x0,y0,z0,c0,d0

      c0 = 0.
      d0 = sin(ulat(1,j_match))

      do i = 1,nlng
        x0(i) = cos(ulat(i,j_match))*cos(ulng(i,j_match))
        y0(i) = cos(ulat(i,j_match))*sin(ulng(i,j_match))
        z0(i) = sin(ulat(i,j_match))
      enddo

c   ... displaced-pole grid above j_match
        
      yy = 0.0
      phiold = phi_match + yy
      dy = 0.01d0*pi/180.  ! 100th of a degree 

      do j = j_match,nlat-1

        do i = 1,nlng
          hte(i,j+1) = 0.0
          htn(i,j+1) = 0.0
        enddo

        jj = j
        if(j.gt.nlat-jcon)jj=nlat-jcon

        fy = dsig*pi/180.d0
        fy = 1.0d0 - (1.0d0-deq/dxavg)*exp(-0.5*(phiold/fy)**2)

        do n = 1,nlast

c         ...set alpha0, phi0

          yy = yy + dy
          delta = yy/(pi-phi_pole-phi_match)
          delta = pi*delta*0.5d0
          delta = sin(delta)
          alpha0 = pi*0.5d0 - (pi*0.5d0-phi_pole)*delta
          phi0 = phi_match + yy

          c00 = c0
          d00 = d0
          do i = 1,nlng
            x00(i) = x0(i)
            y00(i) = y0(i)
            z00(i) = z0(i)
          enddo

          call jcircle(j,nlng,nlat,alpha0,phi0    ! input
     &                ,x0,y0,z0,c0,d0             ! input, output
     &                ,htep,htnp)                 ! output

c         ...increment sum for hte

          if (hte(ii,j+1)+htep(ii).ge.fy*htn(ii,jj)) go to 1000

          do i = 1,nlng
            hte(i,j+1) = hte(i,j+1) + htep(i)
          enddo

        enddo

1000    continue

        yu = yy
        yl = yy - dy

        do n = 1,nlast

          yy = 0.5d0*(yu + yl)
          delta = yy/(pi-phi_pole-phi_match)
          delta = pi*delta*0.5d0
          delta = sin(delta)
          alpha0 = pi*0.5d0 - (pi*0.5d0-phi_pole)*delta
          phi0 = phi_match + yy
          c0 = c00
          d0 = d00
          do i = 1,nlng
            x0(i) = x00(i)
            y0(i) = y00(i)
            z0(i) = z00(i)
          enddo

          call jcircle(j,nlng,nlat,alpha0,phi0    ! input
     &                ,x0,y0,z0,c0,d0             ! input, output
     &                ,htep,htnp)                 ! output

          gg = fy*htn(ii,jj) - (hte(ii,j+1)+htep(ii))

c         if (abs(gg).le.0.1d0) go to 2000
          if (abs(gg).le.1.0d0) go to 2000
          if(gg.gt.0.0d0) then
            yl = yy
          else
            yu = yy
          endif

        enddo

        print *, "no converge: ", fy*htn(ii,jj),hte(ii,j+1)+htep(ii)
2000    continue

        do i = 1,nlng
          hte(i,j+1) = hte(i,j+1) + htep(i)
        enddo
      
        phiold = phi0
        ydeg(j+1) = phi0
c       print *, j+1,phi0*180.d0/pi,n,fy

c       ...find ulat, ulng, and angle utan
c          also copy htn to 2d array

        do i = 1,nlng

          htn(i,j+1) =  htnp(i)

          ulat(i,j+1) = asin(z0(i))
          if (x0(i).ne.0.0d0.or.y0(i).ne.0.0d0) 
     &      ulng(i,j+1) = atan2(y0(i),x0(i))

          delta = sqrt((y0(i)**2*(1.d0+c0**2)+(c0*z0(i)-x0(i))**2)
     &          *(1.d0-z0(i)**2))
          delta = (z0(i)*d0-1.d0)/delta
          if (abs(delta).gt.1.d0) delta = sign(1.d0,delta)
          utan(i,j+1) = sign(acos(-delta),c0*y0(i))

        enddo

c     ...symmetrize right and left hemispheres

        do i = 1,nlng/2

          iii = nlng - i
          htn(iii+1,j+1) = htn(i,j+1)
          hte(iii,j+1)   = hte(i,j+1)
          ulng(iii,j+1)  = 2.d0*pi - ulng(i,j+1)
          ulat(iii,j+1)  = ulat(i,j+1)
          utan(iii,j+1)  = -utan(i,j+1)

        enddo

      enddo

C     print *, " output hte(1,:) to file? (1-yes, 0-no)"
C     read(*,*) n
C     if(n.eq.1)then
C       open(77,file='hte.dat',form='formatted',status='unknown')
C       do j=1,nlat
C         write(77,*) j,hte(1,j)
C       enddo
C       close(77)
C     endif

C     print *, " "
C     do j = 0,nlat-1
C       if(j.eq.0)then
C         print *, j,ydeg(j)
C       else
C         print *, j,ydeg(j)*180./pi,(ulat(ii,j)-ulat(ii,j-1))*180./pi
C       endif
C     enddo

c   ... print min,center,max latitudes of last circle

      print *, " "
      print *, " latitudes of highest circle"
      print *, "  low point:",
     &  (180.d0/pi)*acos((c0*d0 + sqrt(1.d0+c0**2-d0**2))/(1.d0+c0**2))
      print *, "     center:",
     &  (180.d0/pi)*acos((c0*d0)/(1.d0+c0**2))
      print *, " high point:",
     &  (180.d0/pi)*acos((c0*d0 - sqrt(1.d0+c0**2-d0**2))/(1.d0+c0**2))
 
c   ... adjust longitudes 
      do j=0,nlat
         do i=1,nlng
	    ulng(i,j) = mod(ulng(i,j)+lambda_pole+6*pi,2*pi)
         enddo
      enddo
 
c   ...print min cell widths

      dxmin = 1.0d+10
      dymin = 1.0d+10
      do i = 1,nlng
      do j = 1,nlat
        delta = htn(i,j)
        if((delta.lt.dxmin) .and. (delta.ne.0.d0)) then
          imax = i
          jmax = j
          dxmin = delta
        endif
        delta = hte(i,j)
        if((delta.lt.dymin) .and. (delta.ne.0d0)) then
          imin = i
          jmin = j
          dymin = delta
        endif
      enddo
      enddo
      print *, " "
      print *, " min dx :"
      print *, imax,jmax,htn(imax,jmax),htn(nlng/2,nlat)
     &                                 ,htn(1,1)
      print *, " long,lat: "
      print *, ulng(imax,jmax)*180.d0/pi, ulat(imax,jmax)*180.d0/pi
      print *, " "
      print *, " min dy:"
      print *, imin,jmin,hte(imin,jmin)
      print *, " lat,long: "
      print *, ulng(imin,jmin)*180.d0/pi, ulat(imin,jmin)*180.d0/pi
      print *, " "

c   ...print max, min aspect ratios

      dmin = 1.0d0
      dmax = 1.0d0
      smean = 0.0d0
      srms = 0.0d0
      do i = 1,nlng
      do j = 1,nlat
        aspect = htn(i,j)/hte(i,j)
        delta = abs(aspect-dmax)
        if(delta.gt.dmax)then
          imax = i
          jmax = j
          dmax = delta
        endif
        delta = abs(aspect-dmin)
        if(delta.lt.dmin)then
          imin = i
          jmin = j
          dmin = delta
        endif
c       if(aspect.lt.1.0d0) aspect = 1.0d0/aspect
        smean = smean + aspect
        srms = srms + aspect**2
      enddo
      enddo
      print *, " "
      print *, " max aspect ratio:"
      print *, imax,jmax,htn(imax,jmax)/hte(imax,jmax) 
      print *, " long,lat: "
      print *, ulng(imax,jmax)*180.d0/pi, ulat(imax,jmax)*180.d0/pi
      print *, " "
      print *, " min aspect ratio:"
      print *, imin,jmin,htn(imin,jmin)/hte(imin,jmin) 
      print *, " lat,long: "
      print *, ulng(imin,jmin)*180.d0/pi, ulat(imin,jmin)*180.d0/pi
      print *, " "
      print *, " mean aspect ratio:"
      print *, smean/float(nlng*nlat)
      print *, " rms  aspect ratio:"
      print *, sqrt(srms/float(nlng*nlat))
      print *, " "

c   ...output xdeg,ydeg to files

c     open(17,file='xdeg.out',status='unknown')
c     do i=1,nlng
c       write(17,*) xdeg(i)*180.d0/pi, fx(i)*180.d0/pi
c     enddo
c     close(17)

c     open(18,file='ydeg.out',status='unknown')
c     do j=1,nlat
c       write(18,*) ydeg(j)*180.d0/pi, (ydeg(j)-ydeg(j-1))*180.d0/pi
c     enddo
c     close(18)
 
c   ...output circumpherences of j-circles and i-circles

c     open(11,file='jcircle.out',status='unknown')
c     do j = 1,nlat
c       hjcircle(j) = 0.0d0
c       do i = 1,nlng
c         hjcircle(j) = hjcircle(j) + htn(i,j)
c       enddo
c       write(11,*) j, hjcircle(j)*1.d-5  ! (km)
c     enddo
c     close(11)

c     open(12,file='icircle.out',status='unknown')
c     del = 0.0d0
c     do i = 1,nlng
c       hicircle(i) = 0.0d0
c       do j = j_match,nlat
c         hicircle(i) = hicircle(i) + hte(i,j)
c       enddo
c       del = del + hicircle(i)
c     enddo
c     do i = 1,nlng
c       write(12,*) i, (hicircle(i)/del)*360.d0  ! (degrees)
c     enddo
c     close(12)

      end
 
c*********************************************************************

      subroutine jcircle(j,nlng,nlat,alpha0,phi0    ! input
     &                  ,x0,y0,z0,c0,d0             ! input, output
     &                  ,htep,htnp)                 ! output

c     ...

      implicit none
      integer nlng,nlat
      integer i,j,im1,n
      double precision a,b,c0,d0,c,d,c1,d1,c2,atmp,btmp,ctmp,ar,ba,bb
      double precision alph,alpha,phi,xq,zq,sq,radius
      double precision alpha0,phi0,rr
      double precision x,y,z,x1,y1,z1,r1tmp,r2tmp,r3tmp
      double precision p,psi,eps,amu,anu,q,r,delta,rnorm,r1norm 
      double precision x0(1:nlng),y0(1:nlng),z0(1:nlng)
      double precision xi(nlng),yi(nlng),zi(nlng)
      double precision htep(nlng),htnp(nlng)
      data eps,radius/1.d-8,6371.22d5/
      double precision pi
      parameter (pi = 3.141592653589793d0)
      
c---------------------------------------------------------------------

      alph = (sqrt(1.d0+c0**2-d0**2) + c0*d0)/(1.d0+c0**2)
      alph = acos(alph)
c     print *, j,' alph =',alph*180.d0/pi,alpha0*180.d0/pi
      alph = max(alph,alpha0)
c     alph = alpha0
      d1 = 1./sin(alph)
      c1 = (d1 - sin(alph))/cos(alph)
      if (abs(alph-pi/2).lt.eps) then
        psi = 0.0d0
        xq = 0.0d0
        zq = 0.0d0
      else
        xq = (d1 - d0)/(c1 - c0)
        zq = d0 - c0*xq
        psi = atan(zq/xq)
      endif
      phi = phi0 + psi         ! phi(j+1)   in system j
      alpha = alph - psi            ! alpha(j) in system j
      c = sin(phi)/(1.d0/cos(alpha) + cos(phi)) ! c(j+1) " "
      d = c/cos(alpha)                        ! d(j+1) " "
      anu = atan(c)
      if(abs(cos(alpha)).gt.eps) then
         r3tmp = sin(anu)/cos(alpha)
      else
         r3tmp = 0.d0
      endif
      r2tmp = sqrt(1.d0 - r3tmp*r3tmp)

      do i = 1,nlng

c       ... rotate to find x(j),y(j),z(j) in system j

        x1 =  x0(i)*cos(psi) + z0(i)*sin(psi)
        z1 = -x0(i)*sin(psi) + z0(i)*cos(psi)
        y1 =  y0(i)

c       ...solving px^2 + 2qx + r = 0

        if (abs(y1).gt.abs(x1-cos(alpha))) then
          ar = (cos(alpha)-x1)/y1
          ba = cos(alpha)
          bb = sign(1.0d0,ar)*cos(alpha)
          p = 1.d0 + (1.d0+c**2)*ar**2
          q = -(ba + c*d*ar**2)
          r = ba**2 + (d**2 - 1.d0)*ar**2
          sq = q*q - r*p
          delta = sqrt(max(sq,0.d0))
          if (i.eq.nlng .or. bb*(nlng/2-i).lt.0.d0) then
            x = (-q+delta)/p
          else
            x = (-q-delta)/p
          endif
          z = d - c*x
          y = sqrt(max(1.d0 - z**2 - x**2,0.d0))
          if(i.gt.nlng/2) y = -y
          rr = sqrt(x**2+y**2+z**2)
          x=x/rr
          y=y/rr
          z=z/rr
          if(abs(ar).gt.eps) then
            amu = atan(1.d0/ar)
          else
            amu = pi/2.d0
          endif
        else
          a = y1/(cos(alpha)-x1)
          b = a*cos(alpha)
          p = 1.d0 + a**2 + c**2
          q = -(c*d+a*b)
          r = d**2 + b**2 - 1.d0
          sq = q*q - r*p
          delta = sqrt(max(sq,0.d0))
          if (i.eq.nlng .or. b*(nlng/2-i).lt.0.d0) then
            x = (-q+delta)/p
          else
            x = (-q-delta)/p
          endif
          y = b - a*x
          z = d - c*x
          r = sqrt(x**2+y**2+z**2)
          x=x/r
          y=y/r
          z=z/r
          amu = atan(a)
        endif

c       ...rotation of angle -psi around the y-axis

        y0(i)=y
        x0(i)=cos(-psi)*x+sin(-psi)*z
        z0(i)=-sin(-psi)*x+cos(-psi)*z
        r = sqrt(x0(i)**2+y0(i)**2+z0(i)**2)
        x0(i) = x0(i)/r
        y0(i) = y0(i)/r
        z0(i) = z0(i)/r

36      format(2i5,x,4e11.4)
 
c       ...rotate to find c0,d0

        c1 =  c*cos(-psi) + sin(-psi)
        c2 = -c*sin(-psi) + cos(-psi)
        c0 = c1/c2
        d0 = d/c2
 
c       ... calculate hte

        delta = sin(amu)*cos(alpha)
        r1tmp = sqrt(1. - delta*delta)
        p = delta*sin(amu)
        q = delta*cos(amu)
        rnorm = sqrt((x-p)**2+(y-q)**2+z**2)
        r1norm = sqrt((x1-p)**2+(y1-q)**2+z1**2)
        atmp = (x-p)*(x1-p)
        btmp = (y-q)*(y1-q)
        ctmp = z*z1
        delta = (atmp + btmp + ctmp)/(rnorm*r1norm)
c       if (delta.gt.1.0d0) then
c         print *, i,j,delta,abs(x1-cos(alpha))
        delta = min(delta,1.0d0)
c       endif
        delta = acos(delta)
        htep(i) = r1tmp*delta*radius

c       ... calculate temporaries needed to calculate htn

        atmp = r3tmp*sin(anu)
        btmp = r3tmp*cos(anu)
        xi(i) = x - atmp
        yi(i) = y
        zi(i) = z - btmp

      enddo

c     ... calculate htn

      do i = 1,nlng

        im1 = i-1
        if (i.eq.1) im1 = nlng
        atmp = xi(i)*xi(im1)
        btmp = yi(i)*yi(im1)
        ctmp = zi(i)*zi(im1)
        delta = acos((atmp + btmp + ctmp)/(r2tmp**2))
        htnp(i) = r2tmp*delta*radius

      enddo

      end

c*********************************************************************

 
c|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
c     end file dipole.f
c|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

program gridkmt_nc2bin

!-------------------------------------------------------------------------------
! PURPOSE:
! o Reads the kmt field from a netCDF file generated using grid2nc
!   and writes it out as a standard POP binary kmt file.
!-------------------------------------------------------------------------------

use netcdf

implicit none

!--- local ---
   integer         :: io_record_length,nx,ny
   integer         :: did,fid,vid,rcode
   integer, allocatable :: kmt(:,:),kmtin(:,:)
   character(len=80) :: filein, fileout,dname

   print *, 'Enter netCDF filename containing kmt array:'
   read *, filein
   print *, 'Enter POP binary output file name:'
   read *, fileout

   rcode = nf90_open(filein,NF90_NOWRITE,fid)
   rcode = nf90_inq_dimid(fid, 'longitude' , did)
   rcode = nf90_Inquire_Dimension(fid, did, dname, nx  )
   rcode = nf90_inq_dimid(fid, 'latitude' , did)
   rcode = nf90_Inquire_Dimension(fid, did, dname, ny  )

   allocate(kmtin(nx,ny)) 
   allocate(kmt(nx,ny-1)) 

   rcode = nf90_inq_varid(fid,'kmt'  ,vid)
   rcode = nf90_get_var(fid,vid,kmtin)
   rcode = nf90_close(fid)

   kmt = kmtin(1:nx,2:ny)

   inquire(iolength=io_record_length) kmt(1:nx,1:ny-1)
   open(10, access='direct', file=trim(fileout), &
                recl=io_record_length, status='unknown')
   write(10, rec=1) kmt
   close(10)


end program gridkmt_nc2bin

program topography_driver

   implicit none
   integer     :: nlat,nlng,nlev

   print *, " "
   print *, "enter grid dimensions: nlng,nlat,nlev "
   read(*,*) nlng,nlat,nlev
   print *, ">>>>>",nlng,nlat,nlev

   call topography(nlng,nlat,nlev)

end program topography_driver

!---------------------------------------------------------------------

subroutine topography(nlng,nlat,nlev)

   implicit none

   integer  :: nlng,nlat,nlev,n,iocean,jocean
   real*8     ::  ulat(nlng,0:nlat),ulng(nlng,0:nlat)
   real*8     ::  h(nlng,0:nlat)
   integer  ::  kmt(nlng,nlat)
   integer  ::  nxt, nyt
   real*8     ::  dz(nlev),zt(nlev)
   character*80  :: filename

   print *, " "
   print *, "enter name of direct access file containing"
   print *, "double-precision fields:"
   print *, "ulat(1:nlng,0:nlat),ulng(1:nlng,0:nlat)"
   read(*,'(a80)') filename
   print *, ">>>>>",filename

   open (53, file=filename, form='unformatted', status='old', &
     & access='direct',action='read',recl=(nlat+1)*nlng*8)
   read (53,rec=1) ulat(:,0:nlat)
   read (53,rec=2) ulng(:,0:nlat)
   close(53)
   print *, "file read: ",filename

   call zcalc(nlev,dz,zt)

   call add_topo(nlng,nlat,nlev,ulng,ulat,h)

   print *, " "
   print *, "enter: "
   print *, "  0 to continue "
   print *, "  1 to output depth field H(i,j) to direct access file"
   read(*,*) n
   print *, ">>>>>",n
   if(n.eq.1) then
     print *, " "
     print *, "enter filename"
     read(*,'(a80)') filename
     print *, ">>>>>",filename
     open (54, file=filename, form='unformatted', status='unknown', &
  &   access='direct',action='write',recl=nlat*nlng*8)
     write(54,rec=1) h(:,1:nlat)
     close(54)
     print *, "file written: ",filename
   endif

   call depth_levels(nlng,nlat,nlev,dz,zt,h,kmt)

   print *, " "
   print *, "enter: "
   print *, "  0 to continue "
   print *, "  1 to remove isolated points at all levels from KMT"
   read(*,*) n
   print *, ">>>>>",n
   if (n.eq.1) call remove_isolated_points(nlng,nlat,nlev,kmt)

   print *, " "
   print *, "enter: "
   print *, "  0 to continue "
   print *, "  1 to remove disconnected bays that are not"
   print *, "    connected to a selected point"
   read(*,*) n
   print *, ">>>>>",n
   if (n.eq.1) then
2       print *, " "
        print *, " enter indices (iocean, jocean) "
        print *, " for a select point in the ocean"
        read(*,*) iocean,jocean
        print *, ">>>>>",iocean,jocean
        if (kmt(iocean,jocean).eq.0) then
          print *, " "
          print *, " that is a land point, try again "
          go to 2
        endif
        call remove_disconnected_bays(iocean,jocean,nlng,nlat,kmt)
   endif

   print *, " "
   print *, "enter: "
   print *, "  0,     to continue "
   print *, &
     & "  n > 0, to force KMT to have a minimum value of n at ocean pts"
   read(*,*) n
   print *, ">>>>>",n
   if(n.gt.0) then
     where(kmt.gt.0) kmt = max(kmt,n)
   endif

   print *, " "
   print *, "enter: "
   print *, "  0 to continue "
   print *, "  1 to output KMT field to direct access file"
   read(*,*) n
   print *, ">>>>>",n
   if(n.eq.1) then
     print *, " "
     print *, "enter filename"
     read(*,'(a80)') filename
     print *, ">>>>>",filename
     open (55, file=filename, form='unformatted', status='unknown', &
  &    access='direct',action='write',recl=nlat*nlng*4)
     write(55,rec=1) kmt
     close(55)
     print *, "file written: ",filename
   endif
    
end subroutine topography

!----------------------------------------------------------------------
 
subroutine zcalc(nlev,dz,zt)
 
!----------------------------------------------------------------------
!     Reads depth profile for number of levels in model grid
!     calculates depths from the profile
!----------------------------------------------------------------------
!      input:
!        nlev = No. of depths in model
!      output:
!        zt = depth to center of each level
!        dz = depth profile
!      external requirement:
!        'in_depths.dat' = ascii file of dz for nlev levels
!----------------------------------------------------------------------
 
   implicit none

   integer :: nlev,k
   real*8    :: dz(nlev),zt(nlev)
   character*80 :: filename
   character(len=*),parameter :: F00 = "(x,i3,x,f12.3,x,f12.3)"

!  read dz depth profile from file
   print *, " "
   print *, " enter name of ascii grid file with depth profile in cm"
   read(*,'(a80)') filename
   print *, ">>>>>",filename

   open(54,file=filename,status='old',form='formatted')
   do k = 1,nlev
      read (54,*) dz(k)
   enddo
!     print *,k,dz
   close (54)
 
   print *, 'file read: ',filename
!     calculate z from dz
 
   zt(0) = 0.
   zt(1)=.5*dz(1)
   do k=2,nlev
      zt(k)=zt(k-1) + 0.5*(dz(k)+dz(k-1))
   enddo
   print *, " "
   print *, "  k       dz(m)       zt(m)"
   do k=0,nlev
      write(*,F00) k,dz(k)*0.01,zt(k)*0.01
   enddo
 
end
 
!---------------------------------------------------------------------
!     subroutine linking the mesh and the topography
!---------------------------------------------------------------------
 
subroutine add_topo(nlng,nlat,nlev,ulng,ulat,h)

   use netcdf

   implicit none

   integer :: nlng,nlat,nlev,nxt,nyt
   real*8    :: ulat(nlng,0:nlat),ulng(nlng,0:nlat)
   real*8    :: h(nlng,0:nlat)
   integer, allocatable :: itopo(:,:)
   real, allocatable    :: topo(:,:)
   real*8    :: x(3,5),ullng(4),ullat(4),pi
   real*8    :: real_lat,real_lng,hh,hland,hocean,xp,yp,zp
   real*8    :: xv1,xv2,xpv,yv1,yv2,ypv,zv1,zv2,zpv,fac
   integer :: i,j,k,i1,i2,im1,j1,l,kp1,ln,la
   integer :: lngmax,lngmin,latmax,latmin,nbland,nbpocean,nbpland
   integer :: did,fid,vid,rcode,vtype,vdims,vnatts,vdimids(2)
   logical :: incell, land
   character*60 :: fname,vname

   character(len=*),parameter :: F00 = "(20i6)"

   pi = 3.141592653589793d0
   fac = nxt/360.
 
!-----------------------------------------------------------------
!     reading topography...
!     The  integer values (depth at each point) are in meters, positive
!     above sealevel, neg. below.
!     The resolution should be at least 1/2degx1/2deg.
!     The data is assumed to have a top latitude row at 90N, and a first
!     longitude column at 0E.
!-----------------------------------------------------------------

   print *, " "
   print *, " reading topo data..."
   print *, " enter name of netcdf file with <topo> field:"
   read(*,'(a60)') fname

   rcode = nf90_open(trim(fname),NF90_NOWRITE,fid)
   rcode = nf90_inq_varid(fid,'topo',vid)
   rcode = nf90_Inquire_Variable(fid,vid,vname,vtype,vdims,vdimids,vnatts)
   rcode = nf90_Inquire_Dimension(fid,vdimids(1),vname,nxt)
   rcode = nf90_Inquire_Dimension(fid,vdimids(2),vname,nyt)
   print *, " dimension of <topo> field: ",nxt,nyt
   allocate(topo(nxt,nyt))
   allocate(itopo(nxt,nyt))
   rcode = nf90_get_var(fid,vid,topo)
   rcode = nf90_close(fid)
 
   do j=1,nyt
      itopo(1:nxt,nyt+1-j) = int(topo(1:nxt,j))
   enddo
 
   fac = nxt/360.
   print *, " "
   print *, " calculating depth field..."
 
!----------------------------------------------------------
!     is there land at T-points?
!----------------------------------------------------------
 
   nbland = 0
!  loop over mesh grid
   do j=1,nlat
      do i=1,nlng
         if (i.eq.1) then
            im1 = nlng
         else
            im1 = i-1
         endif

!     what are the coordonates of the 4 edges of the cell?
         do k=1,4
            if (k.eq.1.or.k.eq.2) then
               j1 = j-1
            else
               j1 = j
            endif
            if (k.eq.1.or.k.eq.4) then
               i1 =  im1
            else
               i1 = i
            endif
            x (1,k) = cos(ulng(i1,j1))*cos(ulat(i1,j1))
            x (2,k) = sin(ulng(i1,j1))*cos(ulat(i1,j1))
            x (3,k) = sin(ulat(i1,j1))
            ullng (k) = ulng(i1,j1)
            ullat (k) = ulat(i1,j1)
         enddo
 
 
!----------------------------------------------------------
!     what are the (long-lat) boundaries of the cell ?
!----------------------------------------------------------
 
         lngmax = int(max(ulng(i,j),ulng(im1,j), &
     &           ulng(i,j-1),ulng(im1,j-1))*180.*fac/pi)+1
         lngmin = int(min(ulng(i,j),ulng(im1,j), &
     &           ulng(i,j-1),ulng(im1,j-1))*180.*fac/pi)+1
         latmin = (90*fac - int(max(ulat(i,j),ulat(i,j-1), &
     &           ulat(im1,j),ulat(im1,j-1))*fac*180./pi)) + 1
         latmax = (90*fac - int(min(ulat(i,j),ulat(i,j-1), &
     &           ulat(im1,j),ulat(im1,j-1))*fac*180./pi)) + 1
         if (float(lngmax-lngmin)/float(nxt).gt.0.25) then
            l = lngmin
            lngmin = lngmax
            lngmax = l+nxt
         endif
 
!----------------------------------------------------------
!     calculation of depth
!----------------------------------------------------------
 
         hland = 0.
         hocean = 0.
         incell = .true.
         land = .false.
         nbpocean =0
         nbpland =0
         do j1=latmin,latmax
            do i2=lngmin,lngmax
 
               i1 = mod(i2,nxt)
               incell = .true.
               real_lng = float(i1-1)*2.*pi/float(nxt)
               real_lat = pi/2.-float(j1-1)*pi/float(nyt)
               xp = cos(real_lng)*cos(real_lat)
               yp = sin(real_lng)*cos(real_lat)
               zp = sin(real_lat)
 
               do k=1,4
                  kp1 = mod(k,4)+1
                  xv1 = x(1,k) - xp
                  yv1 = x(2,k) - yp
                  zv1 = x(3,k) - zp
                  xv2 = x(1,kp1) - xp
                  yv2 = x(2,kp1) - yp
                  zv2 = x(3,kp1) - zp
                  xpv = yv1*zv2 - zv1*yv2
                  ypv =-xv1*zv2 + zv1*xv2
                  zpv = xv1*yv2 - yv1*xv2
                  incell = incell.and.(xpv*xp+ypv*yp+zpv*zp.ge.0)
               enddo
 
               if (incell) goto 20
               goto 10
20               continue
               if (itopo(i1,j1).ge.0.0) then
                  nbpland  = nbpland +1
!     hland = hland + float(itopo(i1,j1))
               else
                  hocean = hocean + float(itopo(i1,j1))
                  nbpocean  = nbpocean +1
               endif
10               continue
            enddo
         enddo
 
         if (nbpland.gt.nbpocean) then
            hh =  0.0
         else
            if (nbpocean+nbpland.eq.0) then
               hh=0.0
               do k=1,4
                  ln = int(ullng(k)*180.*fac/pi)+1
                  la = (90*fac - int(ullat(k)*fac*180./pi)) + 1
                  hh = hh+ itopo(ln,la)
                  nbpocean = 1
               enddo
               hh = hh/4.
!                 print *,i,j,tlng(i,j)*180./pi,tlat(i,j)*180./pi,hh
            else
               hh = (hocean+hland)/float(nbpland+nbpocean)
            endif
         endif
         if (hh.ge.0.0) then
            nbland = nbland +1
         endif
         h(i,j) = -hh*100.0
         enddo
!        print *,'nb de points :',nbland,' pour j ',j
   enddo
 
end subroutine add_topo
 
!----------------------------------------------------------------------
 
subroutine depth_levels(nlng,nlat,nlev,dz,zt,h,kmt)
 
!-----------------------------------------------------------------------
!     find KMT field given H field
!
!     input:
!       H = depth field (cm)
!       Z = model depths (cm)
!       nlng, nlat, nlev = No. of longitudes, latitudes, depths in model
!
!     output:
!       KMT field
!-----------------------------------------------------------------------

   implicit none

   integer :: i,j,k,nlat,nlng,nlev
   real*8    :: h(nlng,0:nlat),dz(nlev),zt(nlev)
   integer :: kmt(nlng,nlat)
   real*8    :: hmin
 
!***********************************************************************

   print *, " "
   print *, " computing kmt field ..."
   print *, " "
   print *, "enter shallow water cuttoff (m)' "
   print *, "  (points with depths shallower than this cuttoff"
   print *, "   will be automatically set to land)"
   read(*,*) hmin
   print *, ">>>>>",hmin
!  hmin=5.
   hmin = hmin*100.   ! convert to cm
 
   do j = 1,nlat
      do i = 1,nlng
         if(h(i,j) .lt. hmin) h(i,j) = 0.0
         if((h(i,j) .ge. hmin) .and. (h(i,j) .lt. zt(1))) &
     &         h(i,j) = zt(1)
         kmt(i,j) = 0
         if(h(i,j) .lt. zt(1))  kmt(i,j) = 0
         if(h(i,j) .ge. zt(nlev)) kmt(i,j) = nlev
      enddo
   enddo
 
   do k = 1,nlev-1
      do j = 1,nlat
         do i = 1,nlng
            if((h(i,j) .ge. zt(k)) .and. (h(i,j) .lt. zt(k+1))) &
     &            kmt(i,j) = k
         enddo
      enddo
   enddo
 
   do i = 1,nlng
      kmt(i,1)    = 0
      kmt(i,nlat) = 0
   enddo
 
end subroutine depth_levels
 
!---------------------------------------------------------------------

subroutine remove_isolated_points(nlng,nlat,nlev,kmt)

!---------------------------------------------------------------------
!     removes isolated points at all levels.
!     (points sandwiched between land on lateral boundaries:
!           land to N and S, or, land to E and W)
!---------------------------------------------------------------------

   implicit none

   integer :: i,j,k,nlng,nlat,nlev
   integer :: im1,ip1,jm1,jp1,nremoved
   integer :: kmt(nlng,nlat), kmtx(nlng,nlat)
   logical :: land,lande,landw,landn,lands

   print *, " "
   print *, "removing isolated points... "

   kmtx = kmt   ! copy kmt into temp array

   do k = nlev,1,-1

10      nremoved = 0

     do i=1,nlng

       if(i.eq.1) then
         im1 = nlng
       else
         im1 = i-1
       endif
       if(i.eq.nlng) then
         ip1 = 1
       else
         ip1 = i+1
       endif

     do j=2,nlat-1    ! j=1 and j=nlat are assumed to be land

       jm1 = j-1 
       jp1 = j+1 

!         ...note: the following must be modified for tripole grids

       land   = k.gt.kmtx(i,j)
       lande  = k.gt.kmtx(ip1,j)
       landw  = k.gt.kmtx(im1,j)
       landn  = k.gt.kmtx(i,jp1)
       lands  = k.gt.kmtx(i,jm1)


       if (.not.land.and.((lande .and. landw).or.(landn.and.lands))) then
         kmtx(i,j) = kmtx(i,j) - 1   ! remove cell at level k
         nremoved = nremoved + 1
       endif

     enddo  ! j
     enddo  ! i 

!       print *, 'points removed this pass: ', k, nremoved
     if (nremoved .ne. 0) go to 10

   enddo    ! k

   kmt = kmtx    ! overwrite kmt 

end subroutine remove_isolated_points

!---------------------------------------------------------------------

subroutine remove_disconnected_bays(iocean,jocean,imt,jmt,KMTX)

!-----------------------------------------------------------------------
!     remove isolated lakes, bays, single points from grid (KMT field)
!     note: this routine assumes land along northern and southern
!     boundaries: KMTX(:,1) = KMTX(:,jmt) = 0
!-----------------------------------------------------------------------

   implicit none

   integer :: i,j,iocean,jocean,imax,imt,jmt
   logical, dimension(imt,jmt) :: MASKC
   integer, dimension(imt,jmt) :: KMTX,KMUX,KINT
   integer, dimension(imt,jmt) :: CFN,CFS,CFE,CFW,I1,I2
   real*4, dimension(imt,jmt) :: CN,CS,CE,CW,C0

   print *, " "
   print *, " removing disconnected bays..."

   do i=1,imt
   do j=1,jmt
     I1(i,j) = i
     I2(i,j) = j
   enddo
   enddo
   KINT = I1 + (I2-1)*imt

   KMUX = min(KMTX,cshift(KMTX,+1,1))
   KMUX = min(KMUX,cshift(KMUX,+1,2))

   CFE = KMUX + cshift(KMUX,-1,2)
   CFW = cshift(CFE,-1,1)
   CFN = KMUX + cshift(KMUX,-1,1)
   CFS = cshift(CFN,-1,2)

   where (CFE.gt.0)
      CFE = 1
   elsewhere
      CFE = imt*jmt + 1
   endwhere

   where (CFW.gt.0)
      CFW = 1
   elsewhere
      CFW = imt*jmt + 1
   endwhere

   where (CFN.gt.0)
      CFN = 1
   elsewhere
      CFN = imt*jmt + 1
   endwhere

   where (CFS.gt.0)
      CFS = 1
   elsewhere
      CFS = imt*jmt + 1
   endwhere

   MASKC = .true.
   where (KMTX.eq.0)
      MASKC = .false.
      KINT = imt*jmt + 1
   endwhere

   imax = (imt+jmt)*3
   do i = 1,imax
      CE = cshift(KINT,+1,1)*(1.0*CFE)
      CW = cshift(KINT,-1,1)*(1.0*CFW)
      CN = cshift(KINT,+1,2)*(1.0*CFN)
      CS = cshift(KINT,-1,2)*(1.0*CFS)
      C0 = KINT*1.0
      where (MASKC)
         KINT = nint(min(CE,CW,CN,CS,C0))
      endwhere
   enddo

!     print *, 'KMTX(iocean,jocean) =', KMTX(iocean,jocean)
!     print *, 'KINT(iocean,jocean) =', KINT(iocean,jocean)

   where (KINT.ne.KINT(iocean,jocean))
      KINT = 0
   elsewhere
      KINT = KMTX
   endwhere

   print *, ' '
   print *, 'surface count =',count(KINT.ne.0)

   KMTX = KINT

end subroutine remove_disconnected_bays

c|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
c     begin file topography.f
c|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
 
      program topography_driver

      implicit none
      integer nlat,nlng,nlev

      print *, " "
      print *, "enter grid dimensions: nlng,nlat,nlev "
      read(*,*) nlng,nlat,nlev

      call topography(nlng,nlat,nlev)

      end program topography_driver

c---------------------------------------------------------------------

      subroutine topography(nlng,nlat,nlev)

      implicit none

      integer nlng,nlat,nlev,n,iocean,jocean
      double precision ulat(nlng,0:nlat),ulng(nlng,0:nlat)
      double precision h(nlng,0:nlat)
      integer kmt(nlng,nlat)
      double precision dz(nlev),zt(nlev)

      character*80 filename

      print *, " "
      print *, "enter name of direct access file containing"
      print *, "double-precision fields:"
      print *, "ulat(1:nlng,0:nlat),ulng(1:nlng,0:nlat)"
      read(*,'(a80)') filename

      open (53, file=filename, form='unformatted', status='old',
     & access='direct',action='read',recl=(nlat+1)*nlng*8)
      read (53,rec=1) ulat(:,0:nlat)
      read (53,rec=2) ulng(:,0:nlat)
      close(53)
      print *, "file read: ",filename

      call zcalc(nlev,dz,zt)

c     call add_topo(nlng,nlat,nlev,ulng,ulat,h)

      print *, " "
      print *, "enter name of direct access file containing"
      print *, "double-precision fields:"
      print *, "H(1:nlng,1:nlat)"
      read(*,'(a80)') filename

      open (53, file=filename, form='unformatted', status='old',
     & access='direct',action='read',recl=nlat*nlng*8)
      read (53,rec=1) h(:,1:nlat)
      close(53)
      print *, "file read: ",filename

      call depth_levels(nlng,nlat,nlev,dz,zt,h,kmt)

      print *, " "
      print *, "enter: "
      print *, "  0 to continue "
      print *, "  1 to remove isolated points at all levels from KMT"
      read(*,*) n
      if (n.eq.1) 
     &    call remove_isolated_points(nlng,nlat,nlev,kmt)

      print *, " "
      print *, "enter: "
      print *, "  0 to continue "
      print *, "  1 to remove disconnected bays that are not"
      print *, "    connected to a selected point"
      read(*,*) n
      if (n.eq.1) then
2000    print *, " "
        print *, " enter indices (iocean, jocean) "
        print *, " for a select point in the ocean"
        read(*,*) iocean,jocean
        if (kmt(iocean,jocean).eq.0) then
          print *, " "
          print *, " that is a land point, try again "
          go to 2000
        endif
        call remove_disconnected_bays(iocean,jocean,nlng,nlat,kmt)
      endif

      print *, " "
      print *, "enter: "
      print *, "  0,     to continue "
      print *, 
     &"  n > 0, to force KMT to have a minimum value of n at ocean pts"
      read(*,*) n
      if(n.gt.0) then
        where(kmt.gt.0) kmt = max(kmt,n)
      endif

      print *, " "
      print *, "enter: "
      print *, "  0 to continue "
      print *, "  1 to output KMT field to direct access file"
      read(*,*) n
      if(n.eq.1) then
        print *, " "
        print *, "enter filename"
        read(*,'(a80)') filename
        open (55, file=filename, form='unformatted', status='unknown',
     &    access='direct',action='write',recl=nlat*nlng*4)
        write(55,rec=1) kmt
        close(55)
        print *, "file written: ",filename
      endif
    
      end subroutine topography

c----------------------------------------------------------------------
c----------------------------------------------------------------------
 
      subroutine zcalc(nlev,dz,zt)
 
c----------------------------------------------------------------------
c     Reads depth profile for number of levels in model grid
c     calculates depths from the profile
c----------------------------------------------------------------------
c      input:
c        nlev = No. of depths in model
 
c      output:
c        zt = depth to center of each level
c        dz = depth profile
 
c      external requirement:
c        'in_depths.dat' = ascii file of dz for nlev levels
c----------------------------------------------------------------------
 
      implicit none

      integer nlev,k
      double precision dz(nlev),zt(nlev)
      character*80 filename

c-------------------------------------------------

c     read dz depth profile from file
c
      print *, " "
      print *, " enter name of ascii grid file with depth profile in cm"
      read(*,'(a80)') filename

      open(54,file=filename,status='old',form='formatted')
      do k = 1,nlev
         read (54,*) dz(k)
      enddo
c     print *,k,dz
      close (54)
 
      print *, 'file read: ',filename
c     calculate z from dz
 
      zt(0) = 0.
      zt(1)=.5*dz(1)
      do k=2,nlev
         zt(k)=zt(k-1) + 0.5*(dz(k)+dz(k-1))
      enddo
      print *, " "
      print *, "  k       dz(m)       zt(m)"
 11   format(x,i3,x,f12.3,x,f12.3)
      do k=0,nlev
         write(*,11) k,dz(k)*0.01,zt(k)*0.01
      enddo
 
      return
 
      end
 
c---------------------------------------------------------------------
c---------------------------------------------------------------------
c     subroutine linking the mesh and the topography
c---------------------------------------------------------------------
c---------------------------------------------------------------------
 
      subroutine add_topo(nlng,nlat,nlev,ulng,ulat,h)

      implicit none

      integer nlng,nlat,nlev
      double precision ulat(nlng,0:nlat),ulng(nlng,0:nlat)
      double precision h(nlng,0:nlat)
      integer ntlng,ntlat
      parameter (ntlng=4320,ntlat=2160)
      integer itopo (ntlng,ntlat)

      double precision x(3,5),ullng(4),ullat(4),pi
      double precision real_lat,real_lng,hh,hland,hocean,xp,yp,zp
      double precision xv1,xv2,xpv,yv1,yv2,ypv,zv1,zv2,zpv
      integer i,j,k,i1,i2,im1,j1,l,kp1,ln,la
      integer lngmax,lngmin,latmax,latmin,nbland,nbpocean,nbpland
      logical incell, land
      character*60 fname

      pi = 3.141592653589793d0

 
c-----------------------------------------------------------------
c     reading topography...
c     The  integer values (depth at each point) are in meters, positive
c     above sealevel, neg. below.
c     The resolution is 5 min. x 5min.
c     The data is organized in full 180 deg. latitude circles
c     beginning at 90N (constant val.) and stepping south to 89 55.0S
c-----------------------------------------------------------------

      print *, " "
      print *, " enter name of topo data file to be used:"
      read(*,'(a60)') fname
      print *, " reading topo data..."


c     fname = './tbase'
      open (55,file=fname,status='old')
 
      do j=1,ntlat
         read(55,800) (itopo(i,j),i=1,ntlng)
 800     format(20i6)
c        if(mod(j,100).eq.0)print *,j
      enddo
 
      close (55)
 

      print *, " "
      print *, " calculating depth field..."
 
c----------------------------------------------------------
c     is there land at T-points?
c----------------------------------------------------------
 
 
      nbland = 0
      do j=1,nlat
         do i=1,nlng
            if (i.eq.1) then
               im1 = nlng
            else
               im1 = i-1
            endif
 
c     what are the coordonates of the 4 edges of the cell?
            do k=1,4
               if (k.eq.1.or.k.eq.2) then
                  j1 = j-1
               else
                  j1 = j
               endif
               if (k.eq.1.or.k.eq.4) then
                  i1 =  im1
               else
                  i1 = i
               endif
               x (1,k) = cos(ulng(i1,j1))*cos(ulat(i1,j1))
               x (2,k) = sin(ulng(i1,j1))*cos(ulat(i1,j1))
               x (3,k) = sin(ulat(i1,j1))
               ullng (k) = ulng(i1,j1)
               ullat (k) = ulat(i1,j1)
            enddo
 
 
c----------------------------------------------------------
c     what are the (long-lat) boundaries of the cell ?
c----------------------------------------------------------
 
            lngmax = int(max(ulng(i,j),ulng(im1,j),
     &           ulng(i,j-1),ulng(im1,j-1))*180.*12./pi)+1
            lngmin = int(min(ulng(i,j),ulng(im1,j),
     &           ulng(i,j-1),ulng(im1,j-1))*180.*12./pi)+1
            latmin = (90*12 - int(max(ulat(i,j),ulat(i,j-1),
     &           ulat(im1,j),ulat(im1,j-1))*12.*180./pi)) + 1
            latmax = (90*12 - int(min(ulat(i,j),ulat(i,j-1),
     &           ulat(im1,j),ulat(im1,j-1))*12.*180./pi)) + 1
            if (float(lngmax-lngmin)/float(ntlng).gt.0.25) then
               l = lngmin
               lngmin = lngmax
               lngmax = l+ntlng
            endif
 
c----------------------------------------------------------
c     calculation of depth
c----------------------------------------------------------
 
            hland = 0.
            hocean = 0.
            incell = .true.
            land = .false.
            nbpocean =0
            nbpland =0
            do j1=latmin,latmax
               do i2=lngmin,lngmax
 
                  i1 = mod(i2,ntlng)
                  incell = .true.
                  real_lng = float(i1)*2.*pi/float(ntlng)
                  real_lat = pi/2.-float(j1)*pi/float(ntlat)
                  xp = cos(real_lng)*cos(real_lat)
                  yp = sin(real_lng)*cos(real_lat)
                  zp = sin(real_lat)
 
                  do k=1,4
                     kp1 = mod(k,4)+1
                     xv1 = x(1,k) - xp
                     yv1 = x(2,k) - yp
                     zv1 = x(3,k) - zp
                     xv2 = x(1,kp1) - xp
                     yv2 = x(2,kp1) - yp
                     zv2 = x(3,kp1) - zp
                     xpv = yv1*zv2 - zv1*yv2
                     ypv =-xv1*zv2 + zv1*xv2
                     zpv = xv1*yv2 - yv1*xv2
                     incell = incell.and.(xpv*xp+ypv*yp+zpv*zp.ge.0)
                  enddo
 
                  if (incell) goto 20
                  goto 10
 20               continue
                  if (itopo(i1,j1).ge.0.0) then
                     nbpland  = nbpland +1
C     hland = hland + float(itopo(i1,j1))
                  else
                     hocean = hocean + float(itopo(i1,j1))
                     nbpocean  = nbpocean +1
                  endif
 
 
 10               continue
 
               enddo
            enddo
 
 
            if (nbpland.gt.nbpocean) then
               hh =  0.0
            else
               if (nbpocean+nbpland.eq.0) then
                  print *,'nbpocean+nbpland.eq.0: ',i,j
                  hh=0.0
                  do k=1,4
                     ln = int(ullng(k)*180.*12./pi)+1
                     la = (90*12 - int(ullat(k)*12.*180./pi)) + 1
                     print *,'     ln,la,ullng,ullat = ',ln, la,
     &                        ullng(k),ullat(k)
                     hh = hh+ itopo(ln,la)
                     nbpocean = 1
                  enddo
                  hh = hh/4.
                  print *,'     hh = ',hh
c                 print *,i,j,tlng(i,j)*180./pi,tlat(i,j)*180./pi,hh
               else
                  hh = (hocean+hland)/float(nbpland+nbpocean)
               endif
            endif
            if (hh.ge.0.0) then
               nbland = nbland +1
            endif
            h(i,j) = -hh*100.0
 
	 enddo
c        print *,'nb de points :',nbland,' pour j ',j
      enddo
 
      end
 
c----------------------------------------------------------------------
 
      subroutine depth_levels(nlng,nlat,nlev,dz,zt,h,kmt)
 
c-----------------------------------------------------------------------
c     find KMT field given H field
c
c     input:
c       H = depth field (cm)
c       Z = model depths (cm)
c       nlng, nlat, nlev = No. of longitudes, latitudes, depths in model
c
c     output:
c       KMT field
c-----------------------------------------------------------------------

      implicit none

      integer nlat,nlng,nlev
      double precision h(nlng,0:nlat)
      integer kmt(nlng,nlat)
      double precision dz(nlev),zt(nlev)
 
      double precision hmin
      integer i,j,k
 
c***********************************************************************

      print *, " "
      print *, " computing kmt field ..."
 
      print *, " "
      print *, "enter shallow water cuttoff (m)' "
      print *, "  (points with depths shallower than this cuttoff"
      print *, "   will be automatically set to land)"
      read(*,*) hmin
      hmin = hmin*100.   ! convert to cm
 
      do j = 1,nlat
         do i = 1,nlng
            if(h(i,j) .lt. hmin) h(i,j) = 0.0
            if((h(i,j) .ge. hmin) .and. (h(i,j) .lt. zt(1)))
     &         h(i,j) = zt(1)
            kmt(i,j) = 0
            if(h(i,j) .lt. zt(1))  kmt(i,j) = 0
            if(h(i,j) .ge. zt(nlev)) kmt(i,j) = nlev
         enddo
      enddo
 
      do k = 1,nlev-1
         do j = 1,nlat
            do i = 1,nlng
               if((h(i,j) .ge. zt(k)) .and. (h(i,j) .lt. zt(k+1)))
     &            kmt(i,j) = k
            enddo
         enddo
      enddo
 
      do i = 1,nlng
         kmt(i,1)    = 0
         kmt(i,nlat) = 0
      enddo
 
      end  ! depth_levels
 
c---------------------------------------------------------------------
c---------------------------------------------------------------------

      subroutine remove_isolated_points(nlng,nlat,nlev,kmt)

c---------------------------------------------------------------------
c     removes isolated points at all levels.
c     (points sandwiched between land on lateral boundaries:
c           land to N and S, or, land to E and W)
c---------------------------------------------------------------------

      implicit none

      integer i,j,k,nlng,nlat,nlev
      integer im1,ip1,jm1,jp1,nremoved
      integer kmt(nlng,nlat), kmtx(nlng,nlat)
      logical land,lande,landw,landn,lands

      print *, " "
      print *, "removing isolated points... "

      kmtx = kmt   ! copy kmt into temp array

      do k = nlev,1,-1

1000    nremoved = 0

        do i=1,nlng

          if(i.eq.1) then
            im1 = nlng
          else
            im1 = i-1
          endif
          if(i.eq.nlng) then
            ip1 = 1
          else
            ip1 = i+1
          endif

        do j=2,nlat-1    ! j=1 and j=nlat are assumed to be land

          jm1 = j-1 
          jp1 = j+1 

c         ...note: the following must be modified for tripole grids

          land   = k.gt.kmtx(i,j)
          lande  = k.gt.kmtx(ip1,j)
          landw  = k.gt.kmtx(im1,j)
          landn  = k.gt.kmtx(i,jp1)
          lands  = k.gt.kmtx(i,jm1)


          if ( .not.land  .and. 
     &         ((lande .and. landw) .or. (landn .and. lands))
     &       ) then
            kmtx(i,j) = kmtx(i,j) - 1   ! remove cell at level k
            nremoved = nremoved + 1
          endif

        enddo  ! j
        enddo  ! i 

c       print *, 'points removed this pass: ', k, nremoved
        if (nremoved .ne. 0) go to 1000

      enddo    ! k

      kmt = kmtx    ! overwrite kmt 

      end subroutine remove_isolated_points

c---------------------------------------------------------------------
c---------------------------------------------------------------------

      subroutine remove_disconnected_bays(iocean,jocean,imt,jmt,KMTX)

c-----------------------------------------------------------------------
c     remove isolated lakes, bays, single points from grid (KMT field)
c     note: this routine assumes land along northern and southern
c     boundaries: KMTX(:,1) = KMTX(:,jmt) = 0
c-----------------------------------------------------------------------

      implicit none

      integer i,j,iocean,jocean,imax,imt,jmt
      logical, dimension(imt,jmt) :: MASKC
      integer, dimension(imt,jmt) :: KMTX,KMUX,KINT
      integer, dimension(imt,jmt) :: CFN,CFS,CFE,CFW,I1,I2
      real*4, dimension(imt,jmt) :: CN,CS,CE,CW,C0

      print *, " "
      print *, " removing disconnected bays..."

      do i=1,imt
      do j=1,jmt
        I1(i,j) = i
        I2(i,j) = j
      enddo
      enddo
      KINT = I1 + (I2-1)*imt

      KMUX = min(KMTX,cshift(KMTX,+1,1))
      KMUX = min(KMUX,cshift(KMUX,+1,2))

      CFE = KMUX + cshift(KMUX,-1,2)
      CFW = cshift(CFE,-1,1)
      CFN = KMUX + cshift(KMUX,-1,1)
      CFS = cshift(CFN,-1,2)

      where (CFE.gt.0)
         CFE = 1
      elsewhere
         CFE = imt*jmt + 1
      endwhere

      where (CFW.gt.0)
         CFW = 1
      elsewhere
         CFW = imt*jmt + 1
      endwhere

      where (CFN.gt.0)
         CFN = 1
      elsewhere
         CFN = imt*jmt + 1
      endwhere

      where (CFS.gt.0)
         CFS = 1
      elsewhere
         CFS = imt*jmt + 1
      endwhere

      MASKC = .true.
      where (KMTX.eq.0)
         MASKC = .false.
         KINT = imt*jmt + 1
      endwhere

      imax = (imt+jmt)*3
      do i = 1,imax
         CE = cshift(KINT,+1,1)*(1.0*CFE)
         CW = cshift(KINT,-1,1)*(1.0*CFW)
         CN = cshift(KINT,+1,2)*(1.0*CFN)
         CS = cshift(KINT,-1,2)*(1.0*CFS)
         C0 = KINT*1.0
         where (MASKC)
            KINT = nint(min(CE,CW,CN,CS,C0))
         endwhere
      enddo

c     print *, 'KMTX(iocean,jocean) =', KMTX(iocean,jocean)
c     print *, 'KINT(iocean,jocean) =', KINT(iocean,jocean)

      where (KINT.ne.KINT(iocean,jocean))
         KINT = 0
      elsewhere
         KINT = KMTX
      endwhere

      print *, ' '
      print *, 'surface count =',count(KINT.ne.0)

      KMTX = KINT

      end subroutine remove_disconnected_bays

 
c|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
c     end file topography.f
c|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

      subroutine add_topo(nlng,nlat,nlev,ulng,ulat,h,lmask)

      implicit none

      integer nlng,nlat,nlev
      double precision ulat(nlng,0:nlat),ulng(nlng,0:nlat)
      double precision h(nlng,0:nlat)
      integer ntlng,ntlat,lmask(nlng,0:nlat)
      parameter (ntlng=10800,ntlat=5400)
      real rtopo (ntlng,ntlat)

      double precision x(3,5),ullng(4),ullat(4),pi
      double precision real_lat,real_lng,hh,hland,hocean,xp,yp,zp
      double precision xv1,xv2,xpv,yv1,yv2,ypv,zv1,zv2,zpv
      integer i,j,k,i1,i2,im1,j1,l,kp1,ln,la
      integer lngmax,lngmin,latmax,latmin,nbland,nbpocean,nbpland
      logical incell, land
      character*80 fname

      pi = 3.141592653589793d0

 
c-----------------------------------------------------------------
c     reading topography...
c     The  integer values (depth at each point) are in meters, positive
c     above sealevel, neg. below.
c     The resolution is 2 min. x 2min.
c     The data is organized in full 180 deg. latitude circles
c     beginning at 90N (constant val.) and stepping south to 89 55.0S
c-----------------------------------------------------------------

      print *, " "
      print *, " reading topo data..."

c  dataset below archived at /project/oce/bryan/etopo_merge_bedmap.da
      fname = '/cgd/oce/yeager/obs/topo/etopo_merge_bedmap.da'
      open (55, file=fname, form='unformatted', status='old',
     & access='direct',action='read',recl=ntlat*ntlng*4)
      read (55,rec=1) rtopo
      close(55)
 
      print *, " "
      print *, "read rtopo. r(5000,2500) = ",rtopo(5000,2500) 
      print *, "calculating depth field..."
 
c----------------------------------------------------------
c     is there land at T-points?
c----------------------------------------------------------

      where(ulng.gt.pi) ulng=ulng-2.0*pi
 
      nbland = 0
      do j=1,nlat
         print *, " j = ",j
         do i=1,nlng
            if (i.eq.1) then
               im1 = nlng
            else
               im1 = i-1
            endif
 
c     what are the coordonates of the 4 edges of the cell?
            do k=1,4
               if (k.eq.1.or.k.eq.2) then
                  j1 = j-1
               else
                  j1 = j
               endif
               if (k.eq.1.or.k.eq.4) then
                  i1 =  im1
               else
                  i1 = i
               endif
               x (1,k) = cos(ulng(i1,j1))*cos(ulat(i1,j1))
               x (2,k) = sin(ulng(i1,j1))*cos(ulat(i1,j1))
               x (3,k) = sin(ulat(i1,j1))
               ullng (k) = ulng(i1,j1)
               ullat (k) = ulat(i1,j1)
          if (i.eq.81.and.j.eq.138) then
           write(6,*) 'ullng,ullat = ',ullng(k),ullat(k)
          endif
            enddo
 
 
c----------------------------------------------------------
c     what are the (long-lat) boundaries of the cell ?
c----------------------------------------------------------

            lngmax = (180.0*30+int(max(ulng(i,j),ulng(im1,j),
     &           ulng(i,j-1),ulng(im1,j-1))*180.*30./pi))+1
            lngmin = (180.0*30+int(min(ulng(i,j),ulng(im1,j),
     &           ulng(i,j-1),ulng(im1,j-1))*180.*30./pi))+1
            latmin = (90*30 - int(max(ulat(i,j),ulat(i,j-1),
     &           ulat(im1,j),ulat(im1,j-1))*30.*180./pi)) + 1
            latmax = (90*30 - int(min(ulat(i,j),ulat(i,j-1),
     &           ulat(im1,j),ulat(im1,j-1))*30.*180./pi)) + 1
            if (float(lngmax-lngmin)/float(ntlng).gt.0.25) then
               l = lngmin
               lngmin = lngmax
               lngmax = l+ntlng
            endif
         if (i.eq.81.and.j.eq.138) then
            write(6,*) 'lngmin,lngmax = ',lngmin,lngmax
            write(6,*) 'latmin,latmax = ',latmin,latmax
         endif
 
c----------------------------------------------------------
c     calculation of depth
c----------------------------------------------------------
 
            hland = 0.
            hocean = 0.
            incell = .true.
            land = .false.
            nbpocean =0
            nbpland =0
            do j1=latmin,latmax
               do i2=lngmin,lngmax
 
                  i1 = mod(i2,ntlng)
                  incell = .true.
                  real_lng = float(i1-1)*2.*pi/float(ntlng)-pi
                  real_lat = pi/2.-float(j1-1)*pi/float(ntlat)
                  xp = cos(real_lng)*cos(real_lat)
                  yp = sin(real_lng)*cos(real_lat)
                  zp = sin(real_lat)
 
                  do k=1,4
                     kp1 = mod(k,4)+1
                     xv1 = x(1,k) - xp
                     yv1 = x(2,k) - yp
                     zv1 = x(3,k) - zp
                     xv2 = x(1,kp1) - xp
                     yv2 = x(2,kp1) - yp
                     zv2 = x(3,kp1) - zp
                     xpv = yv1*zv2 - zv1*yv2
                     ypv =-xv1*zv2 + zv1*xv2
                     zpv = xv1*yv2 - yv1*xv2
                     incell = incell.and.(xpv*xp+ypv*yp+zpv*zp.ge.0)
                  enddo
 
                  if (incell) goto 20
                  goto 10
 20               continue
                  if (rtopo(i1,j1).ge.0.0) then
                     nbpland  = nbpland +1
                  else
                     hocean = hocean + rtopo(i1,j1)
                     nbpocean  = nbpocean +1
                  endif
 
 
 10               continue
 
               enddo
            enddo
         if (i.eq.81.and.j.eq.138) then
            write(6,*) 'nbpland = ',nbpland
            write(6,*) 'nbpocean = ',nbpocean
         endif
 
 
            if (nbpland.gt.(nbpocean)) then
               hh =  0.0
            else
               if (nbpocean+nbpland.eq.0) then
c                 print *,'nbpocean+nbpland.eq.0: ',i,j
                  hh=0.0
                  do k=1,4
                     ln = (-180.0*30-int(ullng(k)*180.*30./pi))+1
                     la = (90*12 - int(ullat(k)*12.*180./pi)) + 1
c                     print *,'     ln,la,ullng,ullat = ',ln, la,
c    &                        ullng(k),ullat(k)
                     hh = hh+ rtopo(ln,la)
c                    print *,'     hh = ',hh
                     nbpocean = 1
                  enddo
                  hh = hh/4.
c                 print *,i,j,tlng(i,j)*180./pi,tlat(i,j)*180./pi,hh
               else
C                 hh = (hocean+hland)/float(nbpland+nbpocean)
                  hh = (hocean)/float(nbpocean)
               endif
            endif
            if (hh.ge.0.0) then
               nbland = nbland +1
            endif
            h(i,j) = -hh*100.0
c	if there is any land in this grid cell, don't smooth later
            if (nbpland.gt.0) then
              lmask(i,j) = 1
            else
              lmask(i,j) = 0
            endif
         if (i.eq.81.and.j.eq.138) then
            write(6,*) 'h = ',h(i,j)
            write(6,*) 'lmask = ',lmask(i,j)
         endif
 
	 enddo
c        print *,'nb de points :',nbland,' pour j ',j
      enddo
 
      end
 

!|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
!BOP
! !ROUTINE: grid_bin2nc
! !INTERFACE:

program grid_bin2nc

! !DESCRIPTION:
! This program takes information from standard POP files and writes a
! netCDF file.  The netCDF file contains all the information needed by
! g3 (= gCubed, a.k.a. Global Grid Generator framework).
!
! The POP binary files use radians and centimeters.  The netCDF file
! uses degrees and meters.
!
! !REVISION HISTORY:

! !USES:

 use netcdf

implicit none

!EOP
!BOC
!-----------------------------------------------------------------------
!
!  local variables
!
!-----------------------------------------------------------------------

   integer, parameter ::         &
     char_len  = 80                     ,&
     log_kind  = kind(.true.)           ,&
     int_kind  = kind(1)                ,&
     i4        = selected_int_kind(6)   ,&
     i8        = selected_int_kind(13)  ,&
     r4        = selected_real_kind(6)  ,&
     r8        = selected_real_kind(13)

integer ::      &
      att_ival,     &! netCDF data type
      att_num,      &! the volatile number currently assigned to an attribute
      dimid, dimid1, dimid2,        &! netCDF dimension id
!D       dimids(NF90_MAX_VAR_DIMS), &
      dim1, dim2,   &! length of longitude, latitude dimensions
      iostatus,     &! status flag
      io_record_length, &
      itype,        &! netCDF data type
      length,       &! number of elements in a dimension
      i, j, k, n,   &
      ncid,         &! netCDF file id
      nsize,        &! size parameter returned by inquire function
      num_atts,     &! number of global attributes
      num_dims,     &! number of dimensions
      num_vars,     &! number of variables
      varid,        &! netCDF variable id
      xtype

   logical(log_kind) :: &
      att_lval           ! temp space for logical attribute

   integer(i4), allocatable :: kmt(:,:), cellId_array(:,:), &
		inc_array(:,:)

   real(r4) :: att_rval       ! temp space for real attribute
   real(r4) :: a, b, c        ! temp variables

   real(r8), allocatable :: nc_array(:,:), binary_array(:,:), &
                 plot_array(:,:), elevation(:,:), dz(:), z(:)

   real(r8) ::     &
      att_dval       ! temp space for double attribute

   logical(log_kind) :: &
      attrib_error        ! error flag for reading attributes
   character(len=80) :: filename

! Parameters(coded as variables)
real(r8) :: PI, DegToRad, MToCm, RadToDeg, CmToM
!D character(len=NF90_MAX_NAME) :: name

PI = 4.0 * atan(1.0)
DegToRad = PI/180.0
RadToDeg = 180.0/PI
MToCm = 100.0
CmToM = 0.01

! Begin executable code
print *, 'Enter length of longitude dimension'
read *, dim1
print *, 'Longitude entered ', dim1

print *, 'Enter length of latitude dimension'
read *, dim2
print *, 'Latitude entered ', dim2

iostatus = nf90_noerr
print *, 'Enter netCDF output filename'
read *, filename
iostatus = nf90_create(path=trim(filename), cmode=nf90_clobber, ncid=ncid)
call check(iostatus)
print *, 'All output data will go to netCDF file ', trim(filename)
!D print *, 'NCID ', ncid

iostatus = nf90_def_dim(ncid=ncid, name='longitude', len=dim1, dimid=dimid1)
call check(iostatus)
!D print *, 'DIMID 1 ', dimid1

iostatus = nf90_def_dim(ncid=ncid, name='latitude', len=dim2+1, dimid=dimid2)
call check(iostatus)
!D print *, 'DIMID 2 ', dimid2

!D iostatus = nf90_Inquire(ncid=ncid, nDimensions = num_dims)
!D call check(iostatus)
!D print *, 'NUMBER OF DIMENSIONS ', num_dims
!D if(num_dims > 0) then
!D     do dimid = 1, num_dims
!D         iostatus = nf90_Inquire_Dimension(ncid=ncid, dimid=dimid, &
!D                                           name=name, len=length)
!D         print *, '      DIM ', dimid, ' NAME ', name, ' LENGTH ', length
!D     end do
!D end if

allocate(nc_array     (0:dim1-1, 0:dim2) )
allocate(inc_array     (0:dim1-1, 0:dim2) )
allocate(cellId_array (0:dim1-1, 0:dim2) )
allocate(binary_array (1:dim1,   1:dim2) )
allocate(plot_array   (1:dim1,   0:dim2) )
allocate(elevation (1:dim1,   1:dim2) )
allocate(kmt (1:dim1,   1:dim2) )

!D print *, 'Dimensions ', dimid1, ' ', dimid2

! Cell ID is defined only for backwards compatibility.  This variable
! will be removed someday.  No realistic data need be stored for it.
iostatus = nf90_def_var(ncid, 'cellId', 4, (/ dimid1, dimid2 /), varid)
call check(iostatus)

! Elevation is negative below sea level
iostatus = nf90_def_var(ncid, 'elevation', 5, (/ dimid1, dimid2 /), varid)
call check(iostatus)
iostatus = nf90_put_att(ncid, varid, 'units', 'meters')
call check(iostatus)
iostatus = nf90_put_att(ncid, varid, 'long_name', 'Topography')
call check(iostatus)

! KMT
iostatus = nf90_def_var(ncid, 'kmt', 5, (/ dimid1, dimid2 /), varid)
call check(iostatus)

! These variables are described in the POP manuals
iostatus = nf90_def_var(ncid, 'ULAT', 5, (/ dimid1, dimid2 /), varid)
call check(iostatus)
iostatus = nf90_def_var(ncid, 'ULON', 5, (/ dimid1, dimid2 /), varid)
call check(iostatus)
iostatus = nf90_def_var(ncid, 'HTN', 5, (/ dimid1, dimid2 /), varid)
call check(iostatus)
iostatus = nf90_def_var(ncid, 'HTE', 5, (/ dimid1, dimid2 /), varid)
call check(iostatus)
iostatus = nf90_def_var(ncid, 'HUS', 5, (/ dimid1, dimid2 /), varid)
call check(iostatus)
iostatus = nf90_def_var(ncid, 'HUW', 5, (/ dimid1, dimid2 /), varid)
call check(iostatus)
iostatus = nf90_def_var(ncid, 'ANGLE', 5, (/ dimid1, dimid2 /), varid)
call check(iostatus)

iostatus = nf90_enddef(ncid)
call check(iostatus)

! cellId
cellId_array = 1
iostatus = nf90_put_var(ncid=ncid, varid=1, values=cellId_array)
call check(iostatus)

! Depth profile normally in [centimeter]
print *, 'Enter depth profile filename'
read *, filename
open(unit=9, access='sequential', action='read', file=trim(filename),  &
                status='old')
print *, 'Depth profile will be read from text file ', trim(filename)

! The depth file is always small, so easier to count the layers than to
! prompt for them.
n = 0
do while(iostatus==0)
   read(unit=9, fmt=*, iostat=iostatus) a
   n = n + 1
end do
n = n - 1
!D print *, 'Number of layers ', n

! After counting the layers, go back to the top of the file and read
! the values.
rewind(unit=9)
allocate(dz(1:n))
allocate(z(1:n))
a = 0.0
do i = 1, n
   read(unit=9, fmt=*, iostat=iostatus) dz(i)
   a = a - 0.01*dz(i) ! Convert to meters, negative below sea level
   z(i) = a
!D    print *, 'Z(', i, ') = ', z(i)
end do

close(unit=9)

inquire(iolength=io_record_length) kmt(1:dim1, 1:dim2)
!D print *, ' Record length for kmt file ', io_record_length

print *, 'Enter KMT filename'
read *, filename
open(unit=10, access='direct', action='read', file=trim(filename), &
                recl=io_record_length, status='old')
print *, 'KMT will be read from binary file ', trim(filename)

! elevation
nc_array = 1.0
read(10, rec=1) kmt

close(unit=10)

! Set an arbitrarily large positive elevation to represent land.
! This value yields a reasonable spread of colors for the ocean.
elevation = 7000.0
do i = 1, n
   where(kmt == i) elevation = z(i)
end do

nc_array(0,        1:dim2) = elevation (dim1,     1:dim2)
nc_array(1:dim1-1, 1:dim2) = elevation (1:dim1-1, 1:dim2)
nc_array(0:dim1-1,      0) = elevation (1:dim1,        1)
iostatus = nf90_put_var(ncid=ncid, varid=2, values=nc_array)
call check(iostatus)
nc_array(0:dim1-1, 1:dim2) = real(kmt (1:dim1, 1:dim2))
nc_array(0:dim1-1,      0) = real(kmt (1:dim1,        1))
iostatus = nf90_put_var(ncid=ncid, varid=3, values=nc_array)
call check(iostatus)

! Horizontal grid points
! To display the horizontal grid correctly we need the coordinates
! of the points at the 'northeast' corner of every T-cell.  This is
! sufficient for the east-west plotting because the coordinates
! wrap around the globe.  Along the 'southern' edge, however, we
! need an extra row of coordinates.  These could be estimated from
! the HTE/HTN values of the cells, but we read them from a pre-existing
! binary file produced for the purpose of plotting.
inquire(iolength=io_record_length) plot_array(1:dim1, 0:dim2)
!D print *, ' Record length for plot file ', io_record_length

print *, 'Enter binary plot filename'
read *, filename
open(unit=10, access='direct', action='read', file=trim(filename), &
                recl=io_record_length, status='old')
print *, 'Grid points will be read from binary file ', trim(filename)

! ULAT
read(10, rec=1) plot_array
nc_array(0,          0:dim2) = RadToDeg * plot_array (dim1,     0:dim2)
nc_array(1:dim1-1,   0:dim2) = RadToDeg * plot_array (1:dim1-1, 0:dim2)
iostatus = nf90_put_var(ncid=ncid, varid=4, values=nc_array)
call check(iostatus)

! ULON
read(10, rec=2) plot_array
nc_array(0,          0:dim2) = RadToDeg * plot_array (dim1,     0:dim2)
nc_array(1:dim1-1,   0:dim2) = RadToDeg * plot_array (1:dim1-1, 0:dim2)
iostatus = nf90_put_var(ncid=ncid, varid=5, values=nc_array)
call check(iostatus)

close(unit=10)

inquire(iolength=io_record_length) binary_array(1:dim1, 1:dim2)
!D print *, ' Record length for binary input ', io_record_length

print *, 'Enter binary grid filename'
read *, filename
open(unit=10, access='direct', action='read', file=trim(filename), &
                recl=io_record_length, status='old')
print *, 'Cell data will be read from binary file ', trim(filename)

! The cell data will all be padded with an extra 'southern' row
! (nc_array(0,:).  The data values used for padding are chosen to
! be inconspicuous when the raw data are displayed.
! HTN
read(10, rec=3) binary_array
nc_array(0,        1:dim2) = CmToM * binary_array (dim1,     1:dim2)
nc_array(1:dim1-1, 1:dim2) = CmToM * binary_array (1:dim1-1, 1:dim2)
nc_array(0:dim1-1,      0) = CmToM * binary_array (1:dim1,        1)
iostatus = nf90_put_var(ncid=ncid, varid=6, values=nc_array)
call check(iostatus)

! HTE
read(10, rec=4) binary_array
nc_array(0,        1:dim2) = CmToM * binary_array (dim1,     1:dim2)
nc_array(1:dim1-1, 1:dim2) = CmToM * binary_array (1:dim1-1, 1:dim2)
nc_array(0:dim1-1,      0) = CmToM * binary_array (1:dim1,        1)
iostatus = nf90_put_var(ncid=ncid, varid=7, values=nc_array)
call check(iostatus)

! HUS
read(10, rec=5) binary_array
nc_array(0,        1:dim2) = CmToM * binary_array (dim1,     1:dim2)
nc_array(1:dim1-1, 1:dim2) = CmToM * binary_array (1:dim1-1, 1:dim2)
nc_array(0:dim1-1,      0) = CmToM * binary_array (1:dim1,        1)
iostatus = nf90_put_var(ncid=ncid, varid=8, values=nc_array)
call check(iostatus)

! HUW
read(10, rec=6) binary_array
nc_array(0,        1:dim2) = CmToM * binary_array (dim1,     1:dim2)
nc_array(1:dim1-1, 1:dim2) = CmToM * binary_array (1:dim1-1, 1:dim2)
nc_array(0:dim1-1,      0) = CmToM * binary_array (1:dim1,        1)
iostatus = nf90_put_var(ncid=ncid, varid=9, values=nc_array)
call check(iostatus)

! ANGLE
read(10, rec=7) binary_array
nc_array(0,        1:dim2) = RadToDeg * binary_array (dim1,     1:dim2)
nc_array(1:dim1-1, 1:dim2) = RadToDeg * binary_array (1:dim1-1, 1:dim2)
nc_array(0:dim1-1,      0) = RadToDeg * binary_array (1:dim1,        1)
iostatus = nf90_put_var(ncid=ncid, varid=10, values=nc_array)
call check(iostatus)

close(unit=10)


!D iostatus = nf90_Inquire(ncid=ncid, nVariables = num_vars)
!D call check(iostatus)
!D print *, 'NUMBER OF VARIABLES ', num_vars
!D if(num_vars > 0) then
!D     do varid = 1, num_vars
!D         iostatus = nf90_Inquire_Variable(ncid=ncid, varid=varid, &
!D                                          name=name, xtype=xtype, &
!D                                          ndims=num_dims,            &
!D                                          dimids=dimids(:num_dims),  &
!D                                          nAtts=num_Atts)
!D         print *, '      VAR ', varid, ' NAME ', name, ' TYPE ', xtype, &
!D              ' N DIMS ', num_dims, ' N ATTS ', num_Atts
!D         do n = 1, num_dims
!D             print *, '                 DIMENSION ID ', n
!D         end do
!D         do att_num = 1, num_Atts
!D             iostatus = nf90_inq_attname(ncid=ncid, varid=varid, &
!D                                          attnum=att_num, name=name)
!D             print *, '                 ATTRIBUTE ', att_num, ' NAMED ', name
!D         end do
!D     end do
!D end if


iostatus = nf90_Close(ncid=ncid)
call check(iostatus)
!D print *, 'CLOSE', ncid

print *, 'DONE'
end program grid_bin2nc

!-----------------------------------------------------------------------
!EOC

 subroutine check(status)
 use netcdf
    integer, intent(in) :: status
    if(status /= nf90_noerr) then
       print *, trim(nf90_strerror(status))
       stop 'ERROR in netcdf'
    end if
 end subroutine check

#!/bin/csh -fv 

set echo
set verbose

set nx      = 100  		# number of i grid lines
set nlatn   = 67   		# number of j grid lines in NH
set nlats   = 49   		# number of j grid lines in SH
set nz      = 25		# number of vertical grid levels
set lonnp   = -38.5   		# longitude of North Pole
set latnp   = 72.5   		# latitude  of North Pole
set lonsp   = 1.1   		# longitude of South Pole
set latsp   = -90   		# latitude  of South Pole
set dyeq    = .6   		# dy in degrees at Equator
set dsig    = 15.  		# Gaussian efold-scale at equator
set jcon    = 10    		# jcon = # rows of constant dy at poles
set popgrid = grid.pop.da	# binary grid file
set pltgrid = grid.plot.da	# binary grid file
set cdfgrid = grid.nc		# netcdf grid file
set depgrid = h.da		# binary depth array
set kmtgrid = kmt.da		# binary kmt file
set vrtgrid = gx3v5_vert_grid	# ascii vertical grid file
set topo     = global_topo2_bath_merge_0.5_15.nc	# netcdf topography dataset
set minz     = 5.		# min z in meters
set mink     = 3		# minimum allowed km value
set iocean   = 50		# ocean (i,j) point used to define
set jocean   = 60		#	contiguous ocean.
@ ny      = $nlatn + $nlats  	# number of j grid lines

# !!!SET PLOTTING VIEWPOINTS BELOW!!!

#################################
# SET HERE FILE INPUT
#################################
cat >! input.ns_dipole << EOF
$nx $nlatn $nlats
$lonnp $latnp
$lonsp $latsp
$dyeq $dsig $jcon
1
$pltgrid
1
$popgrid
EOF

cat >! input.paleotopo << EOF
$nx $ny $nz
$pltgrid
$vrtgrid
$topo
1
$depgrid
$minz
1
0
$mink
1
$kmtgrid
EOF

cat >! input.grid_bin2nc << EOF
$nx
$ny
$cdfgrid
$vrtgrid
$kmtgrid
$pltgrid
$popgrid
EOF

#################################
# RUN GRID ROUTINES
#################################
../bin/ns_dipole < input.ns_dipole  >! output.ns_dipole
../bin/paleotopo < input.paleotopo  >! output.paleotopo
../bin/grid_bin2nc < input.grid_bin2nc

#################################
# CLEAN UP
#################################
#/usr/bin/rm -f input.ns_dipole input.paleotopo input.display_hgrid_land

exit(0)
